-- Addon Support

-- Player Spawn

addHook("PlayerSpawn", function(player)
	player.dragonfromshadow = false
end)

-- Buttons

local BACK = BT_TOSSFLAG

-- Thinker

addHook("ThinkFrame", function(player)
	for player in players.iterate
		if (player.realmo.skin == "ace" and player.wiz) or player.realmo.skin == "draco"
			-- Characters
			
			---- CrispyChars
			
			/*if CC_NeckSkins
				CC_NeckSkins["ace"]
			end*/
			
			if CC_TrickSkins
				CC_TrickSkins["ace"] =
				{{sprite2 = SPR2_SPNG,
				rotation = "random",
				tics = 0},
				{sprite2 = SPR2_EDGE,
				rarity = 2*FRACUNIT,
				rotation = "random",
				tics = 0,
				frames = 1},
				{sprite2 = SPR2_SWIM,
				rotation = "random",
				tics = 0,
				frames = 1}}
			end
			
			/*if CC_DanceSkins
				CC_DanceSkins["ace"]
			end*/
			
			---- Kirby
			
			if kirbyabilitytable and K_AddAbility
				kirbyabilitytable["ace"] = K_AddAbility(K_ELEMENTS, false, "ELEMENTAL")
				kirbyabilitytable[MT_ACEEARTH] = 3
				kirbyabilitytable[MT_ACEBOULDER] = 3
				kirbyabilitytable[MT_ACEWATER] = 2
				kirbyabilitytable[MT_ACEAIR] = 7
				kirbyabilitytable[MT_ACEFIRE] = 1
				kirbyabilitytable["draco"] = 1
				kirbyabilitytable[MT_DRACOFIREBALL] = 1
			end
			
			---- RushChars
			
			if boatchars and player.wiz
				if player.wiz.element == 0
					boatchars["ace"] = {0, 1, 1}
				elseif player.wiz.element == 1
					boatchars["ace"] = {0, 0, 0}
				elseif player.wiz.element == 2
					boatchars["ace"] = {0, 1, 0}
				elseif player.wiz.element == 3
					boatchars["ace"] = {0, 1, 0}
					
					if player.mo.boat and player.mo.boat.valid
						local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
						
						Thok.color = SKINCOLOR_FLAME
						Thok.frame = $|FF_FULLBRIGHT
						Thok.scale = (player.mo.scale*3)/2
						Thok.scalespeed = FRACUNIT/4
						Thok.destscale = 0
					end
				end
			end
			
			---- Shadow
			
			if AddBikeTvInteraction
				AddBikeTvInteraction("ace", function(mo)
					mo.player.dragonfromshadow = true
				end)
			end
			
			-- Maps
			
			---- ???
			
			-- Misc
			
			---- Ringslinger NEO
			
			local rs_loaded = false
			if RingSlinger and not rs_loaded
				rs_loaded = true;
				
				if player.wiz and player.wiz.element != nil
					local AceRings = {RSWPN_STONE, RSWPN_SPLASH, RSWPN_SCATTER, RSWPN_FLAME}
					
					--Define RS NEO stuff here.
					RingSlinger.Skins["ace"] = {
						ammo = 25,--Maximum ammo.
						weapons = {AceRings[player.wiz.element+1], RSWPN_SEEKER}--Main, offhand
					}
					
					-- Switch Ring
					
					if player.playerstate == PST_LIVE and not P_PlayerInPain(player) and not player.wiz.jumpability
					and not player.wiz.slamming and (not player.wiz.banstate or player.wiz.slamtime or player.wiz.slidejump
					or player.wiz.walljump or (player.wiz.divedelay and not player.wiz.diving)) and not player.wiz.casting
					and (player.cmd.buttons & BACK) and (player.lbtap or player.rbtap)
						player.mo.ringslinger.loadout[1] = AceRings[player.wiz.element+1]
					end
				end
				
				RingSlinger.Skins["draco"] = {
					ammo = 25,--Maximum ammo.
					weapons = {RSWPN_EXPLOSION, RSWPN_RAIL}--Main, offhand
				}
			end
			
			---- GS Grind Rails
			
			if GS_RAILS_SKINS
				GS_RAILS_SKINS["ace"] = -- (From the example script)
				{
					JUMP = true, --You can jump off rails with the jump button!
					JUMPBOOST = true, --Gain a minor jumpboost when jumping off a rail? (Up to a certain limit.)
					AIRDRAG = 44, --Airdrag time in tics after hopping off a rail. (35 tics = 1 second)
					
					SIDEHOP = 36, --Specifies the speed of your sidehop speed. If 0, you can't sidehop at all!
					SIDEHOPARC = 0, --If not 0, adds a vertical arc when sidehopping, creating an "arced" sidehop like in modern games.
					SIDEFLIP = SPR2_SPNG, --Do a Modern-style sideflip? Specify a sprite here to use for it! (I recommend SPR2_SPNG for most chars)
					SIDEHOPTIME = 9, --How many tics your sidehop is considered active. If you have a slow sidehop, you probably want more time.
					
					EMERGENCYDROP = false, --If true, you can press CUSTOM3 to emergency-drop through rails.
					CROUCH = true, --If true, you can "crouch" by holding SPIN, gaining more favorable slope momentum at the cost of balance.
					CROUCHBUTTON = BT_CUSTOM2|BT_TOSSFLAG, --Button to crouch with. If set to BT_SPIN|BT_CUSTOM1, it'd be either SPIN or CUSTOM1! 
					AUTOBALANCE = true, --You auto-balance on rails, losing less speed and making it near-impossible to fall off.
					SLOPEPHYSICS = true, --If false, slope physics are ignored.
					MUSTBALANCE = true, --The character must always balance as if crouching, risking falling off at all times like in SA2!
					
					SLOPEMULT = 0, --Percentage modifier of slope momentum. 10 would add 10% more, while -20 would reduce the effect by 20%.
					LAUNCHPOWER = 0, --Percentage modifier of vertical rail-flings. 10 would add 10% more height, while -20 would reduce it by 20%.
					STARTMODIFIER = 0, --Speed percentage modifier when attaching to rails. 10 would increase speed by 10%, while -20 decreases it 20%
					STARTSPEEDCONDITION = 0, --Minimum Speed you must be at before your start speed modifier takes place. If 0, defaults to 30.
					
					HEROESTWIST = 15, --The amount of speed the Heroes-Twist gives, diminishing with gained speed. If 0, you CAN'T twist at all!
					TWISTBUTTON = 0, --What button to press to perform the Heroes Twist. If 0, it mimicks the crouch button.
					ACCELSPEED = 0, --If not 0, you can forcibly accelerate on rails by simply holding forwards.
					ACCELCAP = 48, --This is the speed cap you can manually accelerate to, if you're capable. Defaults to 48.
					AUTODASHMODE = 72, --At what grinding speed you'll automatically enter dashmode. (only if you have SF_DASHMODE!)
					
					MINSPEED = 0, --Minimum speed your character always has when grinding. If not 0, your character can NEVER reverse!
					MAXSPEED = 180, --Your character won't gain more slopespeed than this. If 0, it's infinite.
					
					FORCESPRITE = nil, --Force a sprite2 when grinding, overriding both SPR2_GRND as well as the backup pose.
					FORCEHANGSPRITE = nil, --Force a sprite2 when on hangrails, rather than SPR2_RIDE
					WALLCLINGSPRITE = nil, --Use this sprite2 when readying for a walljump? Otherwise, picks sprite automatically.
					NOWINDLINES = false, --If true, doesn't spawn windlines when moving fast on rails.
					NOSIDEHOPGFX = 0, --If 1, only spawns sidehop ghosts. If 2, only spawns sidehop speedlines. If 3, spawns neither.
					AUTOVERTICALAIM = true, --If set to false, vertical aim will not be autoadjusted while grinding. Loops/Sidecams excepted.
					NOFUNALLOWED = false, --If true, your character cannot use dunce poses with TOSS FLAG.
				}
			end
		end
	end
end)

local camera = nil
local firstperson = false

hud.add(function(v, player, realcamera)
	camera = realcamera
	
	if realcamera.chase
		firstperson = false
	else
		firstperson = true
	end
end, "game")

-- Kirby

rawset(_G, "K_ELEMENTAL", function(checkflags, destroy, late, player)
	if(checkflags)
		if(player.kvars.ablstate)
			return AF_NOFLOAT|AF_NODUCK|AF_NODROP
		else
			return 0
		end
	end
	if(destroy)
		player.kvars.wiz = nil
		
		return
	end
	if(late)
		return
	end
	
	if player.mo and player.kvars.wiz
		local RT = BT_USE|BT_SPIN
		
		local TwoD = twodlevel or (player.mo.flags2 & MF2_TWOD)
		
		-- Magic --
		
		-- Switch Element
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.kvars.wiz.banstate
			if player.lbtap
				player.kvars.wiz.element = $-1
				
				S_StartSound(nil, sfx_tink, player)
			elseif player.rbtap
				player.kvars.wiz.element = $+1
				
				S_StartSound(nil, sfx_tink, player)
			end
		end
		
		if player.kvars.wiz.element < 0
			player.kvars.wiz.element = 3
		elseif player.kvars.wiz.element > 3
			player.kvars.wiz.element = 0
		end
		
		-- Cast
		
		player.kvars.wiz.castangle = player.drawangle
		
		if (player.cmd.buttons & RT) and player.playerstate == PST_LIVE
		and not P_PlayerInPain(player) and not player.kvars.wiz.banstate
		and player.mo.state != S_PLAY_ROLL and not player.kvars.wiz.castrecharge
		and not (gametyperules & GTR_RINGSLINGER) and (not (player.mo.eflags & MFE_UNDERWATER)
		or (player.kvars.wiz.element == 0 or player.kvars.wiz.element == 2))
			if player.kvars.wiz.mana
				player.kvars.wiz.casting = true
				
				if not player.kvars.wiz.castcarry
					player.kvars.wiz.mana = $-1
				end
				
				if player.kvars.wiz.castdelay
					player.kvars.wiz.castdelay = $-1
				end
				
				if player.kvars.wiz.element == 0 and player.kvars.wiz.castdelay == 0
					local Rock = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEEARTH].speed),
					player.mo.y + P_ReturnThrustY(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEEARTH].speed),
					player.mo.z + player.height/3, MT_ACEEARTH,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/4)
					
					if Rock and Rock.valid
						Rock.scale = FRACUNIT/4
						Rock.scalespeed = FRACUNIT/4
						Rock.destscale = FRACUNIT
						Rock.tracer = player.mo
					end
					
					player.kvars.wiz.castdelay = 5
				elseif player.kvars.wiz.element == 1
					local Water = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEWATER].speed),
					player.mo.y + P_ReturnThrustY(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEWATER].speed),
					player.mo.z + player.height/4, MT_ACEWATER,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/4)
					
					if Water and Water.valid
						Water.scale = FRACUNIT/2
						Water.scalespeed = FRACUNIT/8
						Water.destscale = FRACUNIT
						Water.tracer = player.mo
					end
					
					if player.kvars.wiz.castdelay == 0
						player.kvars.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_splish)
					end
				elseif player.kvars.wiz.element == 2
					local Wind = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEAIR].speed),
					player.mo.y + P_ReturnThrustY(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEAIR].speed),
					player.mo.z + player.height/4, MT_ACEAIR,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/4)
					
					if Wind and Wind.valid
						Wind.scale = FRACUNIT/2
						Wind.scalespeed = FRACUNIT/8
						Wind.destscale = FRACUNIT
						Wind.tracer = player.mo
						
						if not S_SoundPlaying(player.mo, sfx_s3kces)
							S_StartSound(player.mo, sfx_s3kces)
						end
					end
					
					if player.kvars.wiz.castcarrymobj and player.kvars.wiz.castcarrymobj.valid
						if (player.kvars.wiz.castcarrymobj.flags & MF_ENEMY)
							player.kvars.wiz.castcarrymobj.wasenemy = true
							player.kvars.wiz.castcarrymobj.flags = $&~MF_ENEMY
						end
						
						if (player.kvars.wiz.castcarrymobj.flags & MF_SPECIAL)
							player.kvars.wiz.castcarrymobj.wasspecial = true
							player.kvars.wiz.castcarrymobj.flags = $&~MF_SPECIAL
						end
						
						local movespeed
						local dist = P_AproxDistance(P_AproxDistance(player.kvars.wiz.castcarrymobj.x - player.mo.x,
						player.kvars.wiz.castcarrymobj.y - player.mo.y), player.kvars.wiz.castcarrymobj.z - player.mo.z)
						if (dist >= 0 and dist < 512*player.mo.scale)
							movespeed = FRACUNIT/3
						else
							movespeed = FRACUNIT
						end
						
						P_TryMove(player.kvars.wiz.castcarrymobj,
						ARTH_Ace.Ease(FRACUNIT/3, player.kvars.wiz.castcarrymobj.x, player.mo.x + FixedMul(cos(player.drawangle),
						player.mo.radius + mobjinfo[player.kvars.wiz.castcarrymobj.type].radius + 150*FRACUNIT)) + player.rmomx,
						ARTH_Ace.Ease(FRACUNIT/3, player.kvars.wiz.castcarrymobj.y, player.mo.y + FixedMul(sin(player.drawangle),
						player.mo.radius + mobjinfo[player.kvars.wiz.castcarrymobj.type].radius + 150*FRACUNIT)) + player.rmomy, true)
						player.kvars.wiz.castcarrymobj.z = ARTH_Ace.Ease(FRACUNIT/3, player.kvars.wiz.castcarrymobj.z, player.mo.z + player.mo.height)
						
						P_SlideMove(player.kvars.wiz.castcarrymobj)
						
						P_InstaThrust(player.kvars.wiz.castcarrymobj, player.kvars.wiz.castcarrymobj.angle, 0)
						P_SetObjectMomZ(player.kvars.wiz.castcarrymobj, 0)
					else
						player.kvars.wiz.castcarry = false
						player.kvars.wiz.castcarrymobj = nil
					end
				elseif player.kvars.wiz.element == 3
					local Flame = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEFIRE].speed),
					player.mo.y + P_ReturnThrustY(nil, player.kvars.wiz.castangle, mobjinfo[MT_ACEFIRE].speed),
					player.mo.z + player.height/4, MT_ACEFIRE,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/4)
					
					if Flame and Flame.valid
						Flame.scale = FRACUNIT/2
						Flame.scalespeed = FRACUNIT/8
						Flame.destscale = FRACUNIT
						Flame.tracer = player.mo
					end
					
					if player.kvars.wiz.castdelay == 0
						player.kvars.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_fire)
					end
				end
				
				player.kvars.ablstate = 1
			else
				player.kvars.wiz.castrecharge = true
			end
			
			if player.mo.state == S_PLAY_STND
			or player.mo.state == S_PLAY_WAIT
				player.mo.state = S_PLAY_STND
			end
		else
			player.kvars.wiz.casting = false
			player.kvars.wiz.castdelay = 0
			
			if player.kvars.wiz.castcarry and player.kvars.wiz.castcarrymobj and player.kvars.wiz.castcarrymobj.valid
				player.kvars.wiz.castcarry = false
				player.kvars.wiz.castcarrymobj = nil
			end
			
			player.kvars.ablstate = 0
		end
		
		if player.xtap and player.kvars.wiz.castrecharge
			player.kvars.wiz.castrecharge = false
		end
		
		if not player.kvars.wiz.casting or player.kvars.wiz.banstate
			player.kvars.wiz.mana = min($+1, 100)
		end
		
		if (player.mo.state == S_PLAY_EDGE
		or (player.mo.state == S_PLAY_ROLL
		and P_IsObjectOnGround(player.mo))) or pso
		or player.powers[pw_carry] == CR_ZOOMTUBE
		or player.powers[pw_carry] == CR_NIGHTSMODE
		or player.powers[pw_carry] == CR_SUNSTARGRAB or player.exiting
		or player.mo.frostburnt or player.frozen or player.dirk_frozen
		or (player.eggride and player.eggride.state)
			player.kvars.wiz.banstate = true
		else
			player.kvars.wiz.banstate = false
		end
	else
		player.kvars.wiz =
		{element = 0,
		ewangle = 0,
		ewnewangle = 0,
		mana = 100,
		casting = false,
		castaim = 0,
		castangle = 0,
		castrecharge = false,
		castdelay = 0,
		castcarry = false,
		castcarrymobj = nil}
	end
	
	player.wiz = player.kvars.wiz
end)