-- Dragon Init

freeslot("MT_ACEDRAGON", "MT_DRACOFIREBALL", "MT_ACEDRAGON_SPAWNER",
"MT_ACEDRAGON_CHAOSEMERALD", "SPR2_DIVE", "S_PLAY_DRACODIVE",
"SPR2_FWLK", "SPR2_FRUN", "SPR2_FSKD", "SPR2_FAIR", "SPR2_FSWM",
"sfx_adflap", "sfx_wgdash")

mobjinfo[MT_ACEDRAGON] = {
	doomednum = -1,
	spawnstate = S_PLAY_STND,
	seesound = sfx_s1b3,
	painstate = S_PLAY_PAIN,
	painsound = sfx_altdi1,
	missilestate = S_PLAY_FIRE,
	deathstate = S_PLAY_DEAD,
	xdeathstate = S_PLAY_DRWN,
	raisestate = MT_DRACOFIREBALL,
	deathsound = sfx_altdi1,
	spawnhealth = 1,
	radius = 32*FRACUNIT,
	height = 72*FRACUNIT,
	flags = MF_SHOOTABLE
}

mobjinfo[MT_DRACOFIREBALL] =
{
	doomednum = -1,
	spawnstate = S_SMALLFIREBAR1,
	spawnhealth = 1,
	reactiontime = 8,
	seesound = sfx_s1b3,
	deathsound = sfx_s1b3,
	speed = 24*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	displayoffset = 1,
	mass = DMG_FIRE,
	damage = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY|MF_FLOAT|MF_FIRE
}

mobjinfo[MT_ACEDRAGON_SPAWNER] =
{
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	deathsound = sfx_ncspec,
	spawnhealth = 1,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_ACEDRAGON_CHAOSEMERALD] =
{
	doomednum = -1,
	spawnstate = S_CEMG1,
	deathsound = sfx_ncspec,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

states[S_PLAY_DRACODIVE] = {SPR_PLAY, SPR2_DIVE, -1, nil, 0, 0, S_PLAY_FALL}

-- Buttons

local A = BT_JUMP
local B = BT_CUSTOM2
local X = BT_USE|BT_SPIN if srb2p X = BT_CUSTOM3 end
local Y = BT_CUSTOM3 if srb2p Y = 0 end
local BACK = BT_TOSSFLAG

-- Dragon Setup

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.realmo and player.realmo.skin == "ace"
		and not player.bot and player.wiz and not srb2p and not pso
			player.spawning = false
			player.spawntime = 100
			
			player.mounttime = 10
			player.dismounttime = 10
			
			player.droptime = 10
			
			player.duration = 0
			
			if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and not player.wiz.banstate and not player.powers[pw_carry]
			and not player.wiz.ondragon and not player.dragonfromshadow
				local dist = 0
				local inrange = false
				
				if player.wiz.dragon and player.wiz.dragon.valid
					dist = P_AproxDistance(P_AproxDistance(player.mo.x - player.wiz.dragon.x, player.mo.y - player.wiz.dragon.y), player.mo.z - player.wiz.dragon.z)
					
					if (dist >= 0 and dist < 256*player.mo.scale)
						inrange = true
					else
						inrange = false
					end
					
					if player.ytap and (dist >= 0 and dist < 64*player.mo.scale)
					or (player.cmd.buttons & Y) and player.mounttime <= 9 and not player.mo.issucked
						if player.mounttime
							player.mounttime = $-1
						else
							player.wiz.ondragon = true
							
							P_MoveOrigin(player.mo, player.wiz.dragon.x, player.wiz.dragon.y, player.wiz.dragon.z)
							
							R_SetPlayerSkin(player, "draco")
							player.mo.color = player.wiz.dragon.color
							
							player.mounttime = 10
							
							player.firing = false
							player.firetime = 0
							player.flying = false
							player.wingflap = 0
							player.gliding = false
							player.glidetime = 0
							player.glidedelay = 0
							player.quickflap = 0
							player.crouching = false
							player.forcecrouch = false
							player.diving = false
							player.divetime = 0
							player.divedelay = 0
							player.dashtime = 0
							player.dashdelay = 0
							player.slidetime = 0
							player.heightchange = false
						end
					else
						player.mounttime = 10
					end
				end
				
				-- TODO: let a player ride on a player playing as draco.
				
				if not player.wiz.dragon or not inrange
					if (player.cmd.buttons & Y) //and All7Emeralds(emeralds)
					and (player.spawning or not player.duration) and not player.mo.issucked
						if player.spawntime
							if player.spawntime == 90
								local spawner = P_SpawnMobj(
								player.mo.x + player.rmomx + FixedMul(cos(player.drawangle), player.mo.radius + mobjinfo[MT_ACEDRAGON].radius + 100*FRACUNIT),
								player.mo.y + player.rmomy + FixedMul(sin(player.drawangle), player.mo.radius + mobjinfo[MT_ACEDRAGON].radius + 100*FRACUNIT),
								player.mo.z + player.mo.momz, MT_ACEDRAGON_SPAWNER)
								
								spawner.tracer = player.mo
								
								for i = 1, 7
									local emerald = P_SpawnMobj(spawner.x, spawner.y, spawner.z, MT_ACEDRAGON_CHAOSEMERALD)
									
									emerald.tracer = spawner
									emerald.target = player.mo
									emerald.state = S_CEMG1+(i-1)
									emerald.angle = FixedAngle((360*FRACUNIT)/7)
									emerald.scale = 0
									emerald.destscale = emerald.tracer.scale
									emerald.number = i
								end
							end
							
							player.spawning = true
							player.spawntime = $-1
						end
					else
						player.spawning = false
						player.spawntime = min($+1, 100)
					end
					
					if player.spawntime <= 90
						player.wiz.banstate = true
					end
				end
			elseif player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and player.dragonfromshadow and not player.wiz.ondragon
				if player.wiz.dragon and player.wiz.dragon.valid
					player.wiz.ondragon = true
					
					P_MoveOrigin(player.wiz.dragon, player.mo.x, player.mo.y, player.mo.z)
					
					R_SetPlayerSkin(player, "draco")
					player.mo.color = player.wiz.dragon.color
					
					player.flying = true
					player.wingflap = 20
					player.gliding = false
					player.crouching = false
					player.forcecrouch = false
					player.diving = false
					player.divedelay = 0
					player.dashtime = 0
					player.dashdelay = 0
					player.slidetime = 0
					player.heightchange = false
					
					if player.dragonfromshadow
						player.dragonfromshadow = false
					end
				else
					local spawner = P_SpawnMobj(
					player.mo.x + player.rmomx,
					player.mo.y + player.rmomy,
					player.mo.z + player.mo.momz, MT_ACEDRAGON_SPAWNER)
					
					spawner.tracer = player.mo
					
					player.spawning = true
					player.spawntime = 0
				end
			end
		end
	end
end)

-- Dragon Thinker

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.tracer and mobj.tracer.valid and mobj.tracer.player.wiz
			-- Thinker
			
			mobj.health = mobj.tracer.health
			
			if mobj.tracer.player.wiz.ondragon
				if not G_GametypeHasTeams()
					mobj.color = R_GetColorByName(mobj.tracer.player.skincolor+46)
				else
					mobj.color = R_GetColorByName(mobj.tracer.player.skincolor)
				end
				
				mobj.skin = "ace"
				
				mobj.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
				
				P_MoveOrigin(mobj,
				mobj.tracer.x + FixedMul(cos(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 15*FRACUNIT),
				mobj.tracer.y + FixedMul(sin(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 15*FRACUNIT),
				mobj.tracer.z + mobj.tracer.height/3 * P_MobjFlip(mobj.tracer))
				
				mobj.angle = mobj.tracer.player.drawangle
			else
				if not G_GametypeHasTeams()
					mobj.color = R_GetColorByName(mobj.tracer.player.skincolor-46)
				else
					mobj.color = R_GetColorByName(mobj.tracer.player.skincolor)
				end
				
				mobj.skin = "draco"
				
				if mobj.tracer.player.acehealth
					mobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT&~MF_NOGRAVITY
				else
					mobj.flags = MF_NOCLIP|MF_NOCLIPHEIGHT&~MF_NOGRAVITY
				end
			end
			
			-- State Machine
			
			if mobj.tracer.player.wiz.ondragon or not mobj.tracer.player.acehealth
				if mobj.tracer.player.playerstate != PST_DEAD or mobj.tracer.player.acehealth
					if mobj.tracer.player.powers[pw_carry] != CR_ZOOMTUBE
						mobj.state = S_PLAY_RIDE
					else
						if mobj.state != S_PLAY_ROLL
							mobj.state = S_PLAY_ROLL
						end
					end
					
					if P_PlayerInPain(mobj.tracer.player)
						mobj.state = S_PLAY_PAIN
					end
				else
					if mobj.tracer.player.powers[pw_underwater] or mobj.tracer.player.powers[pw_spacetime]
						mobj.state = S_PLAY_DRWN
					else
						mobj.state = S_PLAY_DEAD
					end
				end
			else
				if P_IsObjectOnGround(mobj)
					mobj.state = S_PLAY_STND
				else
					mobj.state = S_PLAY_FALL
				end
			end
			
			-- Visual
			
			if mobj.tracer.player.wiz.ondragon
				if P_MobjFlip(mobj.tracer) > 0
					mobj.flags2 = $&~MF2_OBJECTFLIP
					mobj.eflags = $&~MFE_VERTICALFLIP
				else
					mobj.flags2 = $|MF2_OBJECTFLIP
					mobj.eflags = $|MFE_VERTICALFLIP
				end
				
				-- Flash player after being hit. (From SRB2 source code)
				
				if (mobj.tracer.player.powers[pw_flashing] > 0 and mobj.tracer.player.powers[pw_flashing] < flashingtics
				and (leveltime & 1) and mobj.tracer.player.playerstate == PST_LIVE)
					mobj.flags2 = $|MF2_DONTDRAW
				else
					mobj.flags2 = $&~MF2_DONTDRAW
				end
				
				mobj.scale = mobj.tracer.scale
			end
		else
			P_RemoveMobj(mobj)
		end
	end
end, MT_ACEDRAGON)

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target and target.valid
		return false
	end
end, MT_ACEDRAGON)

-- Player Spawn

local function DracoInit(player)
	if player.mo and player.mo.valid and player.mo.skin == "draco"
		player.firing = false
		player.firetime = 0
		player.flying = false
		player.wingflap = 0
		player.gliding = false
		player.glidetime = 0
		player.glidedelay = 0
		player.quickflap = 0
		player.crouching = false
		player.forcecrouch = false
		player.diving = false
		player.divetime = 0
		player.divedelay = 0
		player.dashtime = 0
		player.dashdelay = 0
		player.slidetime = 0
		player.heightchange = false
		
		player.acehealth = 3
	end
end

addHook("PlayerSpawn", function(player)
	DracoInit(player)
end)

addHook("BotRespawn", function(player)
	DracoInit(player)
end)

-- Activate Flying and Gliding

---- While Falling

addHook("JumpSpecial", function(player)
	if player.gotflag return end
	
	if player.mo.valid and player.mo.skin == "draco"
	and not (player.pflags & PF_JUMPED) and player.atap
	and not player.flying and not player.dashtime and not (player.pflags & PF_THOKKED)
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			player.flying = true
		end
		
		if not (player.mo.eflags & MFE_UNDERWATER)
			player.pflags = $|PF_THOKKED
			player.wingflap = 25
		end
	end
end)

---- While Jumping

addHook("AbilitySpecial", function(player)
	if player.gotflag return end
	
	if player.mo.valid and player.mo.skin == "draco"
	and not player.flying and not player.dashtime and not (player.pflags & PF_THOKKED)
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			player.flying = true
		end
		
		if not (player.mo.eflags & MFE_UNDERWATER)
			player.pflags = $|PF_THOKKED
			player.wingflap = 25
		end
	end
end)

local camera = nil
local firstperson = false

hud.add(function(v, player, realcamera)
	camera = realcamera
	
	if realcamera.chase
		firstperson = false
	else
		firstperson = true
	end
end, "game")

-- Player Think

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "draco"
		if player.powers[pw_carry] != CR_NIGHTSMODE
			if player.wiz and player.wiz.ondragon and player.wiz.dragon and player.wiz.dragon.valid
				if player.ytap or (player.cmd.buttons & Y) and player.dismounttime <= 9
				and not player.hyper or player.mo.issucked
				or player.playerstate == PST_DEAD or player.exiting
					if player.dismounttime and not player.mo.issucked
					and player.playerstate != PST_DEAD and not player.exiting
						player.dismounttime = $-1
					else
						P_MoveOrigin(player.wiz.dragon, player.mo.x, player.mo.y, player.mo.z)
						
						if player.playerstate != PST_DEAD
							player.wiz.dragon.momx = player.rmomx
							player.wiz.dragon.momy = player.rmomy
						end
						
						player.wiz.dragon.momz = player.mo.momz
						
						P_MoveOrigin(player.mo, player.mo.x + FixedMul(cos(player.drawangle), player.mo.radius - player.wiz.dragon.radius - 15*FRACUNIT),
						player.mo.y + FixedMul(sin(player.drawangle), player.mo.radius - player.wiz.dragon.radius - 15*FRACUNIT), player.mo.z + player.height/3 * P_MobjFlip(player.mo))
						
						R_SetPlayerSkin(player, "ace")
						player.mo.color = player.wiz.dragon.color
						
						player.dismounttime = 10
						
						player.firing = false
						player.firetime = 0
						player.flying = false
						player.wingflap = 0
						player.gliding = false
						player.glidetime = 0
						player.glidedelay = 0
						player.quickflap = 0
						player.crouching = false
						player.forcecrouch = false
						player.diving = false
						player.divetime = 0
						player.divedelay = 0
						player.dashtime = 0
						player.dashdelay = 0
						player.slidetime = 0
						player.heightchange = false
						
						player.wiz.ondragon = false
					end
				else
					player.dismounttime = 10
				end
			end
			
			local TwoD = twodlevel or (player.mo.flags2 & MF2_TWOD)
			
			-- Fly and Glide
			
			if (player.cmd.buttons & A) and player.mo.momz * P_MobjFlip(player.mo) < 0
			and not player.flying and not player.gliding and not player.glidedelay
			and not player.diving and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and not player.banstate and not P_IsObjectOnGround(player.mo)
				player.gliding = true
			end
			
			if player.gliding
				player.glidetime = min($+1, 15)
			else
				player.glidetime = 0
			end
			
			if player.glidedelay
				player.glidedelay = $-1
				
				if player.atap and not (player.mo.eflags & MFE_UNDERWATER)
					player.quickflap = 10
				end
			end
			
			if P_IsObjectOnGround(player.mo) and player.quickflap
				player.quickflap = 0
			end
			
			if player.quickflap
				player.quickflap = $-1
			end
			
			if (player.wingflap or player.flying or (player.gliding and ((player.cmd.buttons & A) or player.glidetime < 15))
			or (player.atap and player.quickflap) or player.dashtime or player.machspeedmode) and player.playerstate == PST_LIVE
			and (not P_PlayerInPain(player) or player.mo.state == S_PLAY_STUN) and (not player.banstate or player.wallbonk)
			and not P_IsObjectOnGround(player.mo) and not player.diving
				if (player.powers[pw_super] or player.powers[pw_sneakers]) -- Set the player speeds. (From SRB2 source code)
					player.acceleration = player.accelstart/2 + (FixedDiv(player.speed, player.mo.scale)>>FRACBITS) * player.acceleration/2
				else
					player.acceleration = player.accelstart + (FixedDiv(player.speed, player.mo.scale)>>FRACBITS) * player.acceleration
				end
				
				if player.wingflap and not (player.mo.eflags & MFE_UNDERWATER)
					if player.wingflap < 15
						if player.mo.momz * P_MobjFlip(player.mo) < 10*FRACUNIT
							P_SetObjectMomZ(player.mo, 19200*player.thrustfactor, true)
						end
						
						if player.wingflap >= 14
							for i = 1, 16
								local Dust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, (player.mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)) and MT_MEDIUMBUBBLE or MT_SPINDUST)
								
								Dust.target = player.mo
								Dust.fuse = TICRATE
								Dust.scale = player.mo.scale
								Dust.destscale = player.mo.scale/8
								
								P_InstaThrust(Dust, i*ANGLE_22h, 20*FRACUNIT)
								P_SetObjectMomZ(Dust, -10*FRACUNIT)
							end
							
							S_StartSound(player.mo, sfx_adflap)
						end
					elseif not P_IsObjectInGoop(player.mo)
						if player.mo.momz * P_MobjFlip(player.mo) > 0
							P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
						elseif player.mo.momz * P_MobjFlip(player.mo) < 0
							P_SetObjectMomZ(player.mo, FRACUNIT*2, true)
						end
						
						if player.mo.momz * P_MobjFlip(player.mo) < -5*FRACUNIT
							P_SetObjectMomZ(player.mo, -5*FRACUNIT)
						end
					end
				else
					if player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_SWIM
						if not player.heightchange
							player.heightchange = true
							P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + player.height/4 * P_MobjFlip(player.mo))
						end
						
						player.height = P_GetPlayerSpinHeight(player)
					else
						if player.heightchange
							player.heightchange = false
							P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z - player.height/4 * P_MobjFlip(player.mo))
						end
						
						player.height = skins[player.mo.skin].height
					end
					
					if player.flying or player.btap
						if player.gliding
							player.gliding = false
						end
					end
					
					if player.gliding or player.quickflap
						player.glidedelay = 15
					end
					
					if (player.cmd.buttons & A) and player.flying and not player.dashtime and not player.wallbonk
						if player.mo.momz * P_MobjFlip(player.mo) < player.normalspeed
							P_SetObjectMomZ(player.mo, ((player.mo.eflags & MFE_UNDERWATER) and 7200 or 14400)*player.thrustfactor, true)
						end
					elseif (player.cmd.buttons & B) and player.flying and not player.dashtime and not player.wallbonk
						if player.mo.momz * P_MobjFlip(player.mo) > -player.normalspeed
							P_SetObjectMomZ(player.mo, -((player.mo.eflags & MFE_UNDERWATER) and 3600 or 7200)*player.thrustfactor, true)
						end
					end
					
					if not P_IsObjectInGoop(player.mo) and not player.powers[pw_carry]
						if (player.gliding or player.quickflap) and not player.dashtime and not (player.wallbonk and player.powers[pw_pushing])
							if player.mo.momz * P_MobjFlip(player.mo) > FRACUNIT*2
								if not (player.pflags & PF_STARTJUMP)
									P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
								end
							elseif player.mo.momz * P_MobjFlip(player.mo) < -3*FRACUNIT
								P_SetObjectMomZ(player.mo, FRACUNIT*2, true)
							else
								P_SetObjectMomZ(player.mo, -2*FRACUNIT)
							end
						elseif player.flying or player.dashtime or (player.wallbonk and player.powers[pw_pushing])
							if player.mo.momz * P_MobjFlip(player.mo) > FRACUNIT*((player.mo.eflags & MFE_UNDERWATER/*|Space*/) and 2 or 4)
							and not (player.cmd.buttons & A)
								P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
							elseif player.mo.momz * P_MobjFlip(player.mo) < -FRACUNIT
							and not (player.cmd.buttons & B)
								P_SetObjectMomZ(player.mo, FRACUNIT*((player.mo.eflags & MFE_UNDERWATER/*|Space*/) and 1 or 2), true)
							elseif (player.flying and not (player.cmd.buttons & A) and not (player.cmd.buttons & B))
							or player.dashtime or (player.wallbonk and player.powers[pw_pushing])
								P_SetObjectMomZ(player.mo, 0)
							end
						end
					end
					
					if player.flying and (player.backtap or (player.cmd.buttons & BACK) and player.droptime <= 9)
						if player.droptime
							player.droptime = $-1
						else
							player.flying = false
						end
					else
						player.droptime = 10
					end
				end
			else
				player.flying = false
				
				if player.glidetime >= 15 or P_IsObjectOnGround(player.mo)
					player.gliding = false
				end
			end
			
			if (P_IsObjectOnGround(player.mo) or player.btap) and player.wingflap
				player.wingflap = 0
			end
			
			if player.wingflap
				player.wingflap = $-1
			end
			
			-- Crouch
			
			if player.mo.skin != "ace"
				if (((player.btap and not player.crouching) or ((player.cmd.buttons & B) and player.crouching)
				or (TwoD and player.cmd.forwardmove < -20 and not player.mo.currentaxis)) and player.playerstate == PST_LIVE
				and not P_PlayerInPain(player) and P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo)
				and player.mo.state != S_PLAY_SKID and not player.banstate and not player.flying) or player.forcecrouch
					player.height = P_GetPlayerSpinHeight(player)
					
					player.crouching = true
					
					player.normalspeed = skins[player.mo.skin].normalspeed/2
					
					if abs(player.mo.momx) >= 16*FRACUNIT or abs(player.mo.momy) >= 16*FRACUNIT
						P_SpawnSkidDust(player, player.mo.radius, true)
					end
					
					if player.mo.state == S_PLAY_STND
					or player.mo.state == S_PLAY_WAIT
						player.mo.state = S_PLAY_STND
					end
				else
					player.crouching = false
					
					if not player.flying and not player.gliding and not player.dashtime
						player.height = skins[player.mo.skin].height
					end
					
					player.normalspeed = skins[player.mo.skin].normalspeed
					
					player.acceleration = skins[player.mo.skin].acceleration
				end
				
				-- Ceiling Height Check
				
				if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
				and player.mo.ceilingz - player.mo.floorz < FixedMul(48*FRACUNIT, player.mo.scale)
					player.forcecrouch = true
				else
					player.forcecrouch = false
				end
				
				-- Dive
				
				if ((player.btap and not player.diving) or player.diving) and not player.divedelay
				and not player.banstate and not player.flying and not player.gliding
				and not player.dashtime and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
				and not P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo)
				and not (player.mo.eflags & MFE_SPRUNG) and player.powers[pw_carry] != CR_FAN and not player.gotflag
					if not player.diving
						player.diving = true
						player.divetime = 10
						
						S_StartSound(player.mo, sfx_adflap)
						
						P_InstaThrust(player.mo, player.drawangle, FixedMul(30*FRACUNIT, player.mo.scale))
					end
					
					if (player.mo.momz > -30*FRACUNIT and not (player.mo.eflags & MFE_VERTICALFLIP))
					or (player.mo.momz < 30*FRACUNIT and (player.mo.eflags & MFE_VERTICALFLIP))
						P_SetObjectMomZ(player.mo, max(player.mo.momz - 10*FRACUNIT, -30*FRACUNIT))
					end
				end
				
				if player.diving and (P_IsObjectOnGround(player.mo) or (not player.divetime
				and (player.atap or player.btap)) or P_IsObjectInGoop(player.mo) or P_InQuicksand(player.mo)
				or (player.mo.eflags & MFE_SPRUNG) or player.powers[pw_carry] == CR_FAN
				or player.banstate or player.flying or player.gliding or player.dashtime)
					player.divedelay = 20
					
					if not P_IsObjectOnGround(player.mo)
						if not P_IsObjectInGoop(player.mo) and not P_InQuicksand(player.mo)
						and not (player.mo.eflags & MFE_SPRUNG) and player.powers[pw_carry] != CR_FAN
							player.mo.momz = $/2
						end
						
						S_StartSound(player.mo, sfx_adflap)
					else
						player.divetime = 5
						
						S_StartSound(player.mo, sfx_s3k4c)
						
						for i = 1, 5
							local Dust = P_SpawnMobjFromMobj(player.mo,
							FixedMul(cos(player.drawangle), player.mo.radius + 20*FRACUNIT + player.mo.momx),
							FixedMul(sin(player.drawangle), player.mo.radius + 20*FRACUNIT + player.mo.momy),
							0, (player.mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)) and MT_MEDIUMBUBBLE or MT_SPINDUST)
							
							Dust.target = player.mo
							Dust.fuse = TICRATE
							Dust.scale = player.mo.scale
							Dust.destscale = player.mo.scale/8
							
							P_InstaThrust(Dust, (player.drawangle - ANGLE_67h) + i*ANGLE_22h, 20*FRACUNIT)
							
							Dust.flags = $|MF_MISSILE&~MF_NOCLIP
						end
					end
					
					player.diving = false
				end
				
				if player.divedelay
					player.divedelay = $-1
				end
				
				if player.divetime
					player.divetime = $-1
				end
			end
			
			-- Sprint
			
			if (player.machspeedmode or player.powers[pw_sneakers] or player.powers[pw_super]
			or (player.flying and (player.mo.eflags & MFE_UNDERWATER)))
			and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and not player.banstate and not player.crouching
				if player.powers[pw_sneakers] and (player.cmd.buttons & X)
					if player.gotflag
						player.normalspeed = (skins[player.mo.skin].normalspeed*5)/2
					else
						player.normalspeed = ((skins[player.mo.skin].normalspeed*5)/2)+5
					end
					
					player.charflags = $|SF_DASHMODE|SF_RUNONWATER
					
					if player.speed >= FixedMul(player.runspeed, player.mo.scale) -- Totally Radical! (From SRB2 source code)
						if player.dashmode < 3*TICRATE
							player.dashmode = 3*TICRATE
							
							S_StartSound(player.mo, sfx_rail1)
						end
					else
						player.dashmode = max($-3, 0)
					end
				else
					if player.gotflag
						player.normalspeed = (skins[player.mo.skin].normalspeed*3)/2
					else
						player.normalspeed = ((skins[player.mo.skin].normalspeed*3)/2)+5
					end
					
					player.charflags = $&~SF_DASHMODE
					
					if not player.powers[pw_sneakers]
						player.dashmode = 0
					end
					
					if not player.machspeedmode
						player.charflags = $&~SF_RUNONWATER
					end
				end
				
				if player.machspeedmode and not player.diving
					player.charflags = $|SF_RUNONWATER
					player.gliding = true
				end
				
				//player.thrustfactor = skins[player.mo.skin].thrustfactor*2
			else
				player.thrustfactor = skins[player.mo.skin].thrustfactor
				
				player.dashmode = 0
				player.charflags = $&~SF_DASHMODE
				
				if not player.machspeedmode
					player.charflags = $&~SF_RUNONWATER
				end
			end
			
			if player.mo.state == S_PLAY_DASH and player.dashmode < 3*TICRATE
				player.mo.state = S_PLAY_RUN
			end
			
			-- Dash
			
			if player.xtap and not player.dashtime and not player.dashdelay
			and not player.wingflap and not player.banstate
			and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
				player.dashtime = 25
				player.dashdelay = 100
				
				if P_IsObjectOnGround(player.mo)
					P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + player.height/(player.crouching and 8 or 4) * P_MobjFlip(player.mo))
				end
				
				/*for i = 1, 16
					local Dust = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height/2, (player.mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)) and MT_MEDIUMBUBBLE or MT_SPINDUST)
					
					Dust.target = player.mo
					Dust.fuse = TICRATE
					Dust.scale = player.mo.scale
					Dust.destscale = player.mo.scale/8
					
					P_InstaThrust(Dust, i*ANGLE_22h, 20*FRACUNIT)
				end*/
				
				if not player.powers[pw_sneakers]
					S_StartSound(player.mo, sfx_wgdash)
				else
					S_StartSound(player.mo, sfx_rail1)
				end
			end
			
			if player.dashtime and not player.banstate
			and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
				local DashSpeed
				if not player.powers[pw_sneakers]
					if player.gotflag
						DashSpeed = 15*FRACUNIT
					else
						DashSpeed = 20*FRACUNIT
					end
				else
					if player.gotflag
						DashSpeed = 35*FRACUNIT
					else
						DashSpeed = 40*FRACUNIT
					end
				end
				
				P_InstaThrust(player.mo, player.drawangle, FixedMul(DashSpeed + (player.speed/2), player.mo.scale))
				
				player.height = P_GetPlayerSpinHeight(player)
				
				player.pflags = $|PF_DRILLING
				player.charflags = $|SF_CANBUSTWALLS
				
				player.dashtime = $-1
			else
				player.pflags = $&~PF_DRILLING
				player.charflags = $&~SF_CANBUSTWALLS
				
				if player.dashdelay
					player.dashdelay = $-1
				end
			end
			
			if player.banstate and player.dashtime
				player.dashtime = 0
			end
			
			-- Fire
			
			if player.rttap and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and player.mo.skin != "ace" and not player.firing and not player.banstate
			and not (gametyperules & GTR_RINGSLINGER) and (not player.wiz or player.wiz and not player.wiz.shield)
				player.firetime = 10
				
				local Fireball = P_SPMAngle(player.mo, MT_DRACOFIREBALL, player.drawangle, (firstperson and 1 or 0))
				
				if Fireball and Fireball.valid
					Fireball.scale = FRACUNIT/2
					Fireball.scalespeed = FRACUNIT/8
					Fireball.destscale = FRACUNIT
					Fireball.tracer = player.mo
				end
				
				if player.mo.state == S_PLAY_STND
				or player.mo.state == S_PLAY_WAIT
					player.mo.state = S_PLAY_STND
				end
			end
			
			if player.firetime
				player.firing = true
				player.firetime = $-1
			else
				player.firing = false
			end
			
			if P_IsObjectOnGround(player.mo) and player.wallbonk
				player.wallbonk = 0
			end
			
			if player.wallbonk
				player.wallbonk = $-1
				
				P_Thrust(player.mo, player.drawangle, FRACUNIT/2)
				
				if player.wallbonk > 15
					player.pflags = $|PF_FULLSTASIS
					
					if not player.powers[pw_pushing]
						player.mo.flags = $|MF_NOGRAVITY
					end
				else
					if P_GetPlayerControlDirection(player) == 2
						player.wallbonk = 1
					end
				end
			end
			
			if (P_IsObjectOnGround(player.mo) and player.wallbonk)
			or player.wallbonk == 1 or player.playerstate != PST_LIVE
			or P_PlayerInPain(player) or player.banstate
				player.mo.flags = $&~MF_NOGRAVITY
			end
			
			-- State Machine
			
			if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
				if player.wingflap
					if player.wingflap <= 1
						if player.mo.state == S_PLAY_ROLL
							player.mo.tics = 8
						end
					else
						if player.mo.state != S_PLAY_ROLL
							player.mo.state = S_PLAY_ROLL
						end
					end
					
					if not srb2p
						player.powers[pw_strong] = STR_FLY
					end
				elseif player.flying and not player.wallbonk
					if not (player.mo.eflags & MFE_UNDERWATER)
						if abs(player.mo.momx) >= 11*FRACUNIT or abs(player.mo.momy) >= 11*FRACUNIT
							player.mo.state = S_PLAY_FLY
						else
							player.mo.state = S_PLAY_FALL
						end
					else
						if (P_GetPlayerControlDirection(player) == 1 and (abs(player.mo.momx) >= 2*FRACUNIT or abs(player.mo.momy) >= 2*FRACUNIT))
						or ((player.cmd.buttons & A|B) and abs(player.mo.momz) >= 2*FRACUNIT)
							if player.mo.state != S_PLAY_SWIM
								player.mo.state = S_PLAY_SWIM
							end
						else
							player.mo.state = S_PLAY_FALL
						end
					end
				elseif player.gliding and not player.wallbonk
					if not (player.mo.eflags & MFE_UNDERWATER)
						if abs(player.mo.momx) >= 11*FRACUNIT or abs(player.mo.momy) >= 11*FRACUNIT
							player.mo.state = S_PLAY_GLIDE
						else
							player.mo.state = S_PLAY_FALL
						end
					else
						if (P_GetPlayerControlDirection(player) == 1 and (abs(player.mo.momx) >= 2*FRACUNIT or abs(player.mo.momy) >= 2*FRACUNIT))
						or ((player.cmd.buttons & A|B) and abs(player.mo.momz) >= 2*FRACUNIT)
							if player.mo.state != S_PLAY_SWIM
								player.mo.state = S_PLAY_SWIM
							end
						else
							player.mo.state = S_PLAY_FALL
						end
					end
				elseif player.quickflap
					player.mo.state = S_PLAY_SPRING
				elseif player.diving
					player.mo.state = S_PLAY_DRACODIVE
					
					if not srb2p
						player.powers[pw_strong] = STR_BOUNCE|STR_SPRING|STR_HEAVY
					end
				elseif player.dashtime and not player.wallbonk
					if player.mo.state != S_PLAY_SWIM
						player.mo.state = S_PLAY_SWIM
					end
					
					if not srb2p
						player.powers[pw_strong] = STR_ANIM|STR_PUNCH
					end
				elseif player.dashmode > 3*TICRATE
					if not srb2p
						player.powers[pw_strong] = STR_METAL
					end
				elseif player.wallbonk
					if not player.powers[pw_pushing]
						if player.mo.state != S_PLAY_STUN
							player.mo.state = S_PLAY_STUN
							player.mo.tics = player.wallbonk
						end
					else
						if player.wallbonk > 15
							player.mo.state = S_PLAY_SPRING
						else
							player.mo.state = S_PLAY_ROLL
						end
					end
					
					if not srb2p
						player.powers[pw_strong] = STR_NONE
					end
				else
					if not player.powers[pw_justlaunched] and not P_IsObjectOnGround(player.mo)
						if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK
						or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_DASH
						or player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_GLIDE
						or player.mo.state == S_PLAY_ACECROUCH or player.mo.state == S_PLAY_ACECRAWL
						or player.mo.state == S_PLAY_DRACODIVE) and not player.powers[pw_carry]
							player.mo.state = S_PLAY_FALL
						end
					elseif player.powers[pw_justlaunched] and not P_IsObjectOnGround(player.mo)
						player.mo.state = S_PLAY_SPRING
					end
					
					if player.powers[pw_carry] == CR_FAN or player.powers[pw_carry] == CR_DUSTDEVIL
						if player.mo.state != S_PLAY_GLIDE
							player.mo.state = S_PLAY_GLIDE
						end
					end
					
					if not srb2p
						player.powers[pw_strong] = STR_NONE
					end
				end
			end
			
			if (player.mo.state == S_PLAY_EDGE
			or (player.mo.state == S_PLAY_ROLL
			and P_IsObjectOnGround(player.mo))) or pso
			or player.powers[pw_carry] == CR_ZOOMTUBE
			or player.powers[pw_carry] == CR_NIGHTSMODE
			or player.exiting or player.wallbonk
			or player.mo.frostburnt or player.frozen or player.dirk_frozen
			or (player.eggride and player.eggride.state)
				player.banstate = true
			else
				player.banstate = false
			end
		end
	end
end)

-- Fire Sprites

local FIRESPRITES = {
	[SPR2_STND] = SPR2_FIRE,
	[SPR2_WALK] = SPR2_FWLK,
	[SPR2_RUN_] = SPR2_FRUN,
	[SPR2_JUMP] = SPR2_FJMP,
	[SPR2_SPNG] = SPR2_FJMP,
	[SPR2_FALL] = SPR2_FAIR,
	[SPR2_RIDE] = SPR2_FRID,
	[SPR2_FLY_] = SPR2_FFLY,
	[SPR2_GLID] = SPR2_FGLD,
	[SPR2_CLNG] = SPR2_FCNG,
	[SPR2_SWIM] = SPR2_FSWM
}

-- Pre Frame

addHook("PreThinkFrame", function()
	for player in players.iterate
		if player.mo and player.mo.prestate
			if player.mo.skin == "draco" and player.mo.state == player.mo.prestate
				player.mo.sprite2 = player.mo.presprite2
				player.mo.frame = player.mo.preframe
			end
			
			player.mo.prestate = nil
		end
	end
end)

-- Post Frame

addHook("PostThinkFrame", function()
	for player in players.iterate
		if player.realmo.skin == "draco"
			if (player.firing and FIRESPRITES[player.mo.sprite2])
			or (player.crouching and (player.mo.sprite2 == SPR2_STND or player.mo.sprite2 == SPR2_WALK))
				player.mo.prestate = player.mo.state
				player.mo.presprite2 = player.mo.sprite2
				player.mo.preframe = player.mo.frame
				
				if player.firing and FIRESPRITES[player.mo.sprite2]
				and not player.crouching
					player.mo.sprite2 = FIRESPRITES[player.mo.sprite2]
				elseif player.crouching
					if player.mo.sprite2 == SPR2_STND
						if player.firing
							player.mo.sprite2 = SPR2_FCRH
						else
							player.mo.sprite2 = SPR2_CRCH
						end
					elseif player.mo.sprite2 == SPR2_WALK
						if player.firing
							player.mo.sprite2 = SPR2_FCRL
						else
							player.mo.sprite2 = SPR2_CRWL
						end
					end
				end
				
				player.mo.frame = player.mo.preframe &~ FF_FRAMEMASK
				player.mo.frame = $ + min(player.mo.preframe & FF_FRAMEMASK, skins["draco"].sprites[player.mo.sprite2].numframes - 1)
			elseif not player.firing and not player.crouching
				if player.mo.state == S_PLAY_STND and player.mo.sprite2 != SPR2_STND
					player.mo.sprite2 = SPR2_STND
				end
			end
		end
	end
end)

-- Wall Collision

addHook("MobjMoveBlocked", function(mo, mobj, wall)
	if mo and mo.valid and mo.player and (mo.skin == "draco" or (mo.skin == "ace"
	and ((mo.player.wiz and mo.player.wiz.ondragon and mo.player.wiz.dragon
	and mo.player.wiz.dragon.valid) or mo.player.powers[pw_super])))
		if mo.player.powers[pw_carry] return end
		
		P_SlideMove(mo)
		
		mo.player.powers[pw_pushing] = 3
		
		if wall and wall.valid
			if (wall.frontsector)
				if (wall.frontsector.ceilingheight == wall.frontsector.floorheight
				and mo.z + mo.height > wall.frontsector.ceilingheight)
					return
				end
			end
			
			if (wall.backsector)
				if (wall.backsector.ceilingheight == wall.backsector.floorheight
				and mo.z + mo.height > wall.backsector.ceilingheight)
					return
				end
			end
			
			local directangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
			
			-- Wall Bonk
			
			if mo.player.flying or mo.player.gliding or mo.player.dashtime
				if abs(mo.player.drawangle - directangle) > ANGLE_45
					if abs(mo.player.speed) >= 24*FRACUNIT
						mo.player.drawangle = R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x, mo.y, wall))
						
						if mo.player.dashtime
							mo.player.wallbonk = 50
							
							P_Thrust(mo, R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x, mo.y, wall)), FixedMul(-25*FRACUNIT, mo.scale))
							
							if not mo.player.flying and not mo.player.gliding
								P_SetObjectMomZ(mo, FixedMul(8*FRACUNIT, mo.scale))
							end
						else
							mo.player.wallbonk = 35
							
							P_InstaThrust(mo, R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x, mo.y, wall)), FixedMul(5*FRACUNIT, mo.scale))
						end
						
						S_StartSound(mo, sfx_s3k49)
					end
				else
					P_ReturnThrustX(mo, directangle, mo.momx)
					P_ReturnThrustY(mo, directangle, mo.momy)
					
					mo.player.drawangle = directangle
				end
			end
			
			if mo.player.wallbonk == 1
				P_Thrust(mo, R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x, mo.y, wall)), -20*FRACUNIT)
				
				S_StartSound(mo, sfx_adflap)
			end
		//elseif mobj and mobj.valid
			
		end
	else
		return
	end
	
	return true
end, MT_PLAYER)

-- Spring Check

local function SpringCheck(mo, spring)
	if not (spring and spring.valid)
	or not (mo and mo.valid) or mo.skin != "draco"
		return
	end
	
	if (spring.flags & MF_SPRING)
	and mo.z <= spring.z + spring.height
	and mo.z + mo.height >= spring.z
		mo.player.slidetime = mobjinfo[spring.type].damage
	end
end

addHook("MobjCollide", SpringCheck, MT_PLAYER)
addHook("MobjMoveCollide", SpringCheck, MT_PLAYER)

-- Player Attacks

addHook("PlayerCanDamage", function(player)
	if player.mo.valid and (player.mo.skin == "draco"
	or (player.mo.skin == "ace" and player.wiz and player.wiz.ondragon
	and player.wiz.dragon and player.wiz.dragon.valid))
		if player.dashtime or (player.diving or player.divetime)
			return true
		end
	end
end)

addHook("MobjThinker", function(spawner)
	if spawner and spawner.valid
		if spawner.tracer.player.spawntime == 1
			if spawner.tracer.player.wiz.dragon and spawner.tracer.player.wiz.dragon.valid
				P_RemoveMobj(spawner.tracer.player.wiz.dragon)
			end
		elseif not spawner.tracer.player.spawntime
			spawner.tracer.player.wiz.dragon = P_SpawnMobj(spawner.x, spawner.y, spawner.z, MT_ACEDRAGON)
			
			if spawner.tracer and spawner.tracer.valid
				spawner.tracer.player.wiz.dragon.tracer = spawner.tracer
				spawner.tracer.player.wiz.dragon.angle = R_PointToAngle2(spawner.tracer.player.wiz.dragon.x, spawner.tracer.player.wiz.dragon.y, spawner.tracer.x, spawner.tracer.y)
			end
			
			spawner.tracer.player.spawning = false
			spawner.tracer.player.spawntime = 100
		end
		
		local dist = P_AproxDistance(P_AproxDistance(spawner.tracer.x - spawner.x, spawner.tracer.y - spawner.y), spawner.tracer.z - spawner.z)
		
		if not spawner.tracer.player.spawning or (dist > 512*spawner.scale)
			P_KillMobj(spawner)
		end
	end
end, MT_ACEDRAGON_SPAWNER)

addHook("MobjThinker", function(emerald)
	if emerald and emerald.valid
		if emerald.tracer and emerald.tracer.valid
			P_MoveOrigin(emerald,
			emerald.tracer.x + P_ReturnThrustX(emerald, emerald.angle * emerald.number, (48 + 50 - emerald.target.player.duration/8) * emerald.scale),
			emerald.tracer.y + P_ReturnThrustY(emerald, emerald.angle * emerald.number, (48 + 50 - emerald.target.player.duration/8) * emerald.scale),
			emerald.tracer.z + emerald.target.player.duration*FRACUNIT/16)
			
			emerald.angle = $ + FixedAngle(emerald.target.player.duration*FRACUNIT/16) / emerald.number
			
			emerald.target.player.duration = $+1
		else
			emerald.destscale = 0
			
			if emerald.scale <= FRACUNIT/96
				emerald.target.player.spawntime = 100
				emerald.target.player.duration = 0
				
				P_KillMobj(emerald)
			end
		end
	end
end, MT_ACEDRAGON_CHAOSEMERALD)

-- Draco's Fireball

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid and mobj.tracer
	and mobj.tracer.player and mobj.tracer.player.valid
		for fof in mobj.subsector.sector.ffloors()
			if not (fof.flags & FF_EXISTS) continue end
			if not (fof.flags & FF_BUSTUP) continue end
			
			if mobj.z + mobj.momz + mobj.height < fof.bottomheight continue end
			if mobj.z + mobj.momz > fof.topheight continue end
			
			EV_CrumbleChain(fof)
		end
		
		local Thok = P_SpawnMobjFromMobj(mobj, 0, 0, -mobj.height/2, MT_THOK)
		
		Thok.color = SKINCOLOR_FLAME
		Thok.frame = $|FF_FULLBRIGHT
		Thok.scale = (mobj.scale*3)/2
		Thok.scalespeed = FRACUNIT/4
		Thok.destscale = 0
		
		mobj.info.speed = 30*FRACUNIT + mobj.tracer.player.speed
	end
end, MT_DRACOFIREBALL)