-- Fairy Init

freeslot("MT_ACEFAIRY", "SPR_SASH", "S_ACEFAIRY_FLOAT", "S_ACEFAIRY_WAIT",
"S_ACEFAIRY_GLIDE", "S_ACEFAIRY_FLY", "S_ACEFAIRY_POINT", "S_ACEFAIRY_SHIELD",
"S_ACEFAIRY_PAIN", "S_ACEFAIRY_LOW", "S_ACEFAIRY_DEAD", "S_ACEFAIRY_DRWN",
"S_ACEFAIRY_ROLL", "S_ACEFAIRY_TWIRL", "MT_ACEFAIRY_WING", "SPR_SWNG",
"S_ACEFAIRY_WING", "MT_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE_POP")

mobjinfo[MT_ACEFAIRY] =
{
	spawnstate = S_ACEFAIRY_FLOAT,
	seesound = sfx_None,
	painstate = S_ACEFAIRY_PAIN,
	deathstate = S_ACEFAIRY_DEAD,
	xdeathstate = S_ACEFAIRY_DRWN,
	spawnhealth = 1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SHOOTABLE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_ACEFAIRY_FLOAT] = {SPR_SASH, A, 105, nil, 0, 0, S_ACEFAIRY_WAIT}
states[S_ACEFAIRY_WAIT] = {SPR_SASH, B|FF_ANIMATE, -1, nil, 3, 16, S_NULL}
states[S_ACEFAIRY_GLIDE] = {SPR_SASH, F|FF_ANIMATE, -1, nil, 7, 4, S_NULL}
states[S_ACEFAIRY_FLY] = {SPR_SASH, N|FF_ANIMATE, -1, nil, 7, 2, S_NULL}
states[S_ACEFAIRY_POINT] = {SPR_SASH, V, -1, A_PlaySeeSound, 0, 0, S_NULL}
states[S_ACEFAIRY_TWIRL] = {SPR_SASH, W, -1, A_PlaySeeSound, 0, 0, S_NULL}
states[S_ACEFAIRY_SHIELD] = {SPR_SASH, X, 4, nil, 0, 0, S_ACEFAIRY_SHIELD}
states[S_ACEFAIRY_PAIN] = {SPR_SASH, Y, 4, nil, 1, 4, S_ACEFAIRY_FLOAT}
states[S_ACEFAIRY_LOW] = {SPR_SASH, Z, 4, nil, 0, 0, S_ACEFAIRY_FLOAT}
states[S_ACEFAIRY_DEAD] = {SPR_SASH, 26, -1, nil, 0, 0, S_NULL}
states[S_ACEFAIRY_DRWN] = {SPR_SASH, 27, -1, nil, 0, 0, S_NULL}
states[S_ACEFAIRY_ROLL] = {SPR_SASH, 28|FF_ANIMATE, -1, nil, 5, 2, S_NULL}

mobjinfo[MT_ACEFAIRY_WING] =
{
	spawnstate = S_ACEFAIRY_WING,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_ACEFAIRY_WING] = {SPR_SWNG, FF_TRANS30|FF_PAPERSPRITE, -1, nil, 0, 0}

mobjinfo[MT_ACEFAIRY_BUBBLE] =
{
	spawnstate = S_ACEFAIRY_BUBBLE,
	deathstate = S_ACEFAIRY_BUBBLE_POP,
	spawnhealth = 1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

states[S_ACEFAIRY_BUBBLE] = {SPR_BUBL, E, -1, nil, 0, 0}
states[S_ACEFAIRY_BUBBLE_POP] = {SPR_BUBL, F, 1, nil, 0, 0, S_NULL}

-- Buttons

local LT = BT_CUSTOM1|BT_FIRENORMAL

-- Fairy Setup

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.mo and player.wiz and (player.mo.skin == "ace" or player.wiz.ondragon)
			if player.wiz.fairy and player.wiz.fairy.valid and player.wiz.fairy.tracer
				local player = player.wiz.fairy.tracer.player
				
				-- Point
				
				if player.ytap and not player.wiz.fairy.point and not player.wiz.shield
				and player.powers[pw_carry] != CR_ZOOMTUBE and not player.mo.issucked
				and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
					player.wiz.fairy.point = 35
				end
				
				if player.wiz.fairy.point
					player.wiz.fairy.point = $-1
				end
				
				if player.wiz.shield or player.powers[pw_carry] == CR_ZOOMTUBE or player.mo.issucked
					if player.wiz.fairy.point > 1
						player.wiz.fairy.point = 1
					end
				end
				
				-- Shield
				
				if player.wiz.parrytime
					player.wiz.parry = true
					player.wiz.parrytime = $-1*TICRATE
				else
					player.wiz.parry = false
				end
				
				if (player.cmd.buttons & LT) and player.playerstate == PST_LIVE
				and not P_PlayerInPain(player) and not player.wiz.shieldrecharge 
				and not player.wiz.shielddelay and not player.wiz.casting
				and player.powers[pw_carry] != CR_ZOOMTUBE
				and not player.gotflag and not player.exiting
				or player.playerstate == PST_LIVE and (player.mo.state != S_PLAY_PAIN
				or (player.pflags & PF_SLIDING)) and player.powers[pw_flashing]
					if player.powers[pw_flashing]
						player.wiz.fairymana = player.powers[pw_flashing]
					end
					
					if player.wiz.fairymana
						player.wiz.shield = true
						player.wiz.fairymana = $-1
						
						if not player.wiz.shieldorb or not player.wiz.shieldorb.valid
							player.wiz.parrytime = 4*TICRATE
							
							player.wiz.shieldorb = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACESHIELD)
							player.wiz.shieldorb.tracer = player.mo
							player.wiz.shieldorb.color = R_GetColorByName(player.wiz.fairy.color)
							
							if player.wiz.shieldorb and player.wiz.shieldorb.valid
								player.wiz.shieldorb.scale = FRACUNIT/4
								player.wiz.shieldorb.scalespeed = FRACUNIT/4
								
								S_StartSound(player.mo, sfx_shield)
							end
						end
					else
						player.wiz.shieldrecharge = true
					end
				else
					if player.wiz.shield
						player.wiz.shield = false
						player.wiz.shielddelay = 15
						
						S_StartSound(player.mo, sfx_ngskid)
					end
					
					player.wiz.fairymana = min($+1, 100)
					
					if player.wiz.shieldorb and player.wiz.shieldorb.valid
						player.wiz.shieldorb.destscale = 0
						
						if player.wiz.shieldorb.scale <= FRACUNIT/96
							P_RemoveMobj(player.wiz.shieldorb)
						end
					end
				end
				
				if player.lttap and player.wiz.shieldrecharge
					player.wiz.shieldrecharge = false
				end
				
				if player.wiz.shielddelay
					player.wiz.shielddelay = $-1
				end
			else
				player.wiz.fairy = P_SpawnMobjFromMobj(player.mo,
				player.rmomx + FixedMul(cos(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustX(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.rmomy + FixedMul(sin(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustY(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.mo.momz + player.mo.height, MT_ACEFAIRY)
				
				if player.realmo
					player.wiz.fairy.tracer = player.mo
				end
				
				player.wiz.fairy.newx = player.wiz.fairy.x
				player.wiz.fairy.newy = player.wiz.fairy.y
				player.wiz.fairy.newz = player.wiz.fairy.z
				
				player.wiz.fairy.side = -1
				
				player.wiz.fairy.sidex = P_ReturnThrustX(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.wiz.fairy.tracer.scale))
				player.wiz.fairy.sidey = P_ReturnThrustY(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.wiz.fairy.tracer.scale))
				
				player.wiz.fairy.point = 0
			end
		end
	end
end)

-- Fairy Thinker

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.tracer and mobj.tracer.valid and mobj.tracer.player.wiz
		and (mobj.tracer.skin == "ace" or (mobj.tracer.skin == "draco"
		and mobj.tracer.player.wiz.ondragon))
			-- Movement
			
			if mobj.tracer.player.acehealth
				if not mobj.target or mobj.point
					if mobj.tracer.player.wiz.wallsliding
						mobj.newx = mobj.tracer.x - FixedMul(cos(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 50*FRACUNIT)
						mobj.newy = mobj.tracer.y - FixedMul(sin(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 50*FRACUNIT)
						
						mobj.side = -mobj.side
					else
						mobj.newx = mobj.tracer.x + FixedMul(cos(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 50*FRACUNIT)
						mobj.newy = mobj.tracer.y + FixedMul(sin(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 50*FRACUNIT)
					end
					
					if mobj.tracer.player.powers[pw_carry] != CR_ZOOMTUBE
						if not (mobj.eflags & MFE_VERTICALFLIP)
							mobj.newz = mobj.tracer.z + mobj.tracer.height
						else
							mobj.newz = mobj.tracer.z - mobj.height
						end
					else
						mobj.newz = mobj.tracer.z
					end
					
					if mobj.tracer.player.playerstate == PST_LIVE and not (mobj.tracer.flags2 & MF2_TWOD)
					and mobj.tracer.player.powers[pw_carry] != CR_NIGHTSMODE and mobj.tracer.player.powers[pw_carry] != CR_ZOOMTUBE
						if leveltime % (12*TICRATE) == 0 and not mobj.tracer.player.wiz.wallsliding
							mobj.side = P_RandomChance(FRACUNIT/2) and -1 or 1
						end
						
						mobj.sidex = ARTH_Ace.Ease(FRACUNIT/12, mobj.sidex, P_ReturnThrustX(mobj, mobj.tracer.player.drawangle - ANGLE_90 * mobj.side, FixedMul(50*FRACUNIT, mobj.tracer.scale)))
						mobj.sidey = ARTH_Ace.Ease(FRACUNIT/12, mobj.sidey, P_ReturnThrustY(mobj, mobj.tracer.player.drawangle - ANGLE_90 * mobj.side, FixedMul(50*FRACUNIT, mobj.tracer.scale)))
					else
						mobj.sidex = 0
						mobj.sidey = 0
					end
					
					if not mobj.point or not mobj.target
						if not mobj.tracer.issucked
							mobj.angle = mobj.tracer.player.drawangle
							+ ((not mobj.target and mobj.point) and mobj.movedir*2 or 0)
						else
							mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.tracer.x, mobj.tracer.y)
						end
					end
				end
			else
				if not mobj.tracer.player.wiz.ondragon
					mobj.newx = mobj.tracer.x + FixedMul(cos(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 15*FRACUNIT)
					mobj.newy = mobj.tracer.y + FixedMul(sin(mobj.tracer.player.drawangle), mobj.tracer.radius - mobj.radius - 15*FRACUNIT)
				else
					mobj.newx = mobj.tracer.player.wiz.dragon.x + mobj.tracer.player.rmomx
					+ FixedMul(cos(mobj.tracer.player.wiz.dragon.angle), mobj.tracer.player.wiz.dragon.radius - mobj.radius - 30*FRACUNIT)
					
					mobj.newy = mobj.tracer.player.wiz.dragon.y + mobj.tracer.player.rmomy
					+ FixedMul(sin(mobj.tracer.player.wiz.dragon.angle), mobj.tracer.player.wiz.dragon.radius - mobj.radius - 30*FRACUNIT)
				end
				
				if not mobj.tracer.player.wiz.ondragon
					if not (mobj.eflags & MFE_VERTICALFLIP)
						mobj.newz = mobj.tracer.z + mobj.tracer.height/4
					else
						mobj.newz = mobj.tracer.z - mobj.height/4
					end
				else
					if not (mobj.eflags & MFE_VERTICALFLIP)
						mobj.newz = mobj.tracer.z + mobj.tracer.height/2
					else
						mobj.newz = mobj.tracer.z - mobj.height/2
					end
				end
				
				mobj.sidex = 0
				mobj.sidey = 0
				
				if not mobj.point or not mobj.target
					mobj.angle = mobj.tracer.player.drawangle
				end
			end
			
			-- Tracker
			
			if mobj.target and mobj.target.valid and (ARTH_Ace.AceCollectible[mobj.target.type] or mobj.target.type == MT_ACEFLOWER)
				if mobj.tracer.player.acehealth and not mobj.point and ARTH_Ace.AceCollectible[mobj.target.type][1]
					mobj.newx = mobj.target.x
					mobj.sidex = 0
					mobj.newy = mobj.target.y
					mobj.sidey = 0
					mobj.newz = mobj.target.z
				end
				
				mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.target.x, mobj.target.y)
				
				local dist = P_AproxDistance(P_AproxDistance(mobj.x - mobj.tracer.x, mobj.y - mobj.tracer.y), mobj.z - mobj.tracer.z)
				
				if (mobj.tracer.player.playerstate != PST_LIVE
				or P_PlayerInPain(mobj.tracer.player)
				or (not (dist >= 0 and dist < 512*mobj.tracer.scale) and not mobj.point)
				or not mobj.target.health or mobj.target.collected
				or mobj.tracer.player.wiz.shield) or mobj.point == 1
					mobj.target = nil
				end
			else
				if not P_PlayerInPain(mobj.tracer.player) and not mobj.tracer.player.wiz.shield
				and mobj.tracer.player.powers[pw_carry] != CR_ZOOMTUBE and not mobj.tracer.issucked
					if not mobj.point and mobj.tracer.player.acehealth
					and ((ARTH_Ace.FetchMode.value == 1 and not G_RingSlingerGametype() and not G_IsSpecialStage(gamemap))
					or (ARTH_Ace.FetchMode.value == 2 and not G_IsSpecialStage(gamemap)) or (ARTH_Ace.FetchMode.value == 3))
						searchBlockmap("objects", function(mo, collectible)
							if collectible and collectible.valid
								if ((ARTH_Ace.AceCollectible[collectible.type] and ARTH_Ace.AceCollectible[collectible.type][1])
								or (collectible.type == MT_REDTEAMRING and mo.tracer.player.ctfteam == 1)
								or (collectible.type == MT_BLUETEAMRING and mo.tracer.player.ctfteam == 2))
									local dist1 = P_AproxDistance(P_AproxDistance(collectible.x - mo.tracer.x, collectible.y - mo.tracer.y), collectible.z - mo.tracer.z)
									local dist2 = P_AproxDistance(P_AproxDistance(mo.x - collectible.x, mo.y - collectible.y), mo.z - collectible.z)
									
									if not mo.target and mo.tracer.player.playerstate == PST_LIVE and not P_PlayerInPain(mo.tracer.player)
									and mo.tracer.player.powers[pw_carry] != CR_NIGHTSMODE and not collectible.target
									and collectible.health and not collectible.collected
										if ((dist1 >= 0 and dist1 < 256*mo.tracer.scale)
										or (dist2 >= 0 and dist2 < 128*mo.tracer.scale))
											mo.target = collectible
										end
									end
								else
									return
								end
							end
						end, mobj,
						mobj.tracer.x - RING_DIST, mobj.tracer.x + RING_DIST,
						mobj.tracer.y - RING_DIST, mobj.tracer.y + RING_DIST)
					elseif mobj.point
						searchBlockmap("objects", function(mo, collectible)
							if collectible and collectible.valid
								if (mo.health and (ARTH_Ace.AceCollectible[collectible.type] and ARTH_Ace.AceCollectible[collectible.type][2])
								or ((collectible.type == MT_REDTEAMRING or collectible.type == MT_RING_REDBOX) and mo.tracer.player.ctfteam == 1)
								or ((collectible.type == MT_BLUETEAMRING or collectible.type == MT_RING_BLUEBOX) and mo.tracer.player.ctfteam == 2))
								or not collectible.health or collectible.collected or (not mo.health and collectible.type == MT_ACEFLOWER)
									if not mo.target and mo.tracer.player.playerstate == PST_LIVE and not P_PlayerInPain(mo.tracer.player)
									and mo.tracer.player.powers[pw_carry] != CR_NIGHTSMODE and not collectible.target
									and collectible.health and not collectible.collected
										A_FindTarget(mo, collectible.type)
									end
								else
									return
								end
							end
						end, mobj,
						mobj.tracer.x - RING_DIST*8, mobj.tracer.x + RING_DIST*8,
						mobj.tracer.y - RING_DIST*8, mobj.tracer.y + RING_DIST*8)
					end
				end
			end
			
			-- Thinker
			
			mobj.health = mobj.tracer.health
			
			local MobjColor -- Can't wait till skincolor 2 comes out.
			if mobj.tracer.player.wiz.ondragon and mobj.tracer.player.wiz.dragon and mobj.tracer.player.wiz.dragon.valid
				MobjColor = mobj.tracer.player.wiz.dragon.color
			else
				MobjColor = mobj.tracer.player.skincolor
			end
			
			if not G_GametypeHasTeams()
				mobj.color = R_GetColorByName(MobjColor+15)
			else
				mobj.color = R_GetColorByName(MobjColor)
			end
			
			if mobj.tracer.player.playerstate != PST_DEAD
				if mobj.tracer.player.acehealth
					mobj.movedir = $ + FixedAngle(8*FRACUNIT)
					
					local movespeed
					local dist = P_AproxDistance(P_AproxDistance(mobj.x - mobj.tracer.x, mobj.y - mobj.tracer.y), mobj.z - mobj.tracer.z)
					if (dist >= 0 and dist <= 1024*mobj.tracer.scale)
						movespeed = FRACUNIT/3
					else
						movespeed = FRACUNIT
					end
					
					P_MoveOrigin(mobj,
					ARTH_Ace.Ease(movespeed, mobj.x, mobj.newx + mobj.sidex
					+ ((not mobj.target and mobj.point) and FixedMul(cos(mobj.movedir*2), 10*FRACUNIT) or 0)),
					ARTH_Ace.Ease(movespeed, mobj.y, mobj.newy + mobj.sidey
					+ ((not mobj.target and mobj.point) and FixedMul(sin(mobj.movedir*2), 10*FRACUNIT) or 0)),
					ARTH_Ace.Ease(movespeed, mobj.z, mobj.newz) + FixedMul(cos(mobj.movedir), FRACUNIT/2))
					
					P_SlideMove(mobj)
					
					mobj.frame = $|FF_FULLBRIGHT
					
					local Shine = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_THOK)
					
					P_MoveOrigin(Shine, mobj.x, mobj.y, mobj.z + (P_MobjFlip(mobj) < 0 and -mobj.height*3 or 0))
					
					Shine.color = mobj.color
					
					local FADEFLAG = {FF_TRANS90, FF_TRANS80, FF_TRANS70, FF_TRANS60}
					Shine.frame = FF_FULLBRIGHT|FADEFLAG[min(mobj.tracer.player.acehealth, 4)]
					
					Shine.scale = mobj.scale
					Shine.scalespeed = FRACUNIT/4
					Shine.destscale = 0
				else
					mobj.movedir = 0
					
					P_MoveOrigin(mobj, mobj.newx, mobj.newy, mobj.newz)
				end
			else
				if not (mobj.flags & MF_NOCLIP)
					mobj.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
					P_SetObjectMomZ(mobj, mobj.tracer.momz)
				end
			end
			
			-- State Machine
			
			if mobj.tracer.player.playerstate != PST_DEAD
				if mobj.tracer.player.powers[pw_carry] != CR_ZOOMTUBE
					if mobj.tracer.player.acehealth
						if abs(mobj.tracer.player.speed) < 10*FRACUNIT
						and not mobj.target and not mobj.point
							if mobj.state != S_ACEFAIRY_FLOAT and mobj.state != S_ACEFAIRY_WAIT
								mobj.state = S_ACEFAIRY_FLOAT
							end
						elseif abs(mobj.tracer.player.speed) >= 10*FRACUNIT
						and abs(mobj.tracer.player.speed) < 25*FRACUNIT
						and not mobj.target and not mobj.point
							if mobj.state != S_ACEFAIRY_GLIDE
								mobj.state = S_ACEFAIRY_GLIDE
							end
						elseif abs(mobj.tracer.player.speed) >= 25*FRACUNIT
						or mobj.target and not mobj.point
							if mobj.state != S_ACEFAIRY_FLY
								mobj.state = S_ACEFAIRY_FLY
							end
						end
					else
						mobj.state = S_ACEFAIRY_LOW
					end
					
					if mobj.point
						if mobj.target
							if mobj.state != S_ACEFAIRY_POINT
								mobj.state = S_ACEFAIRY_POINT
							end
						else
							if mobj.state != S_ACEFAIRY_TWIRL
								mobj.state = S_ACEFAIRY_TWIRL
							end
						end
					end
					
					if mobj.tracer.player.wiz.shield and not mobj.point
						mobj.state = S_ACEFAIRY_SHIELD
					end
				else
					if mobj.state != S_ACEFAIRY_ROLL
						mobj.state = S_ACEFAIRY_ROLL
					end
				end
				
				if P_PlayerInPain(mobj.tracer.player)
					mobj.state = S_ACEFAIRY_PAIN
				end
			else
				if mobj.tracer.player.powers[pw_underwater] or mobj.tracer.player.powers[pw_spacetime]
					mobj.state = S_ACEFAIRY_DRWN
				else
					mobj.state = S_ACEFAIRY_DEAD
				end
			end
			
			-- Visual
			
			if P_MobjFlip(mobj.tracer) > 0
				mobj.flags2 = $&~MF2_OBJECTFLIP
				mobj.eflags = $&~MFE_VERTICALFLIP
			else
				mobj.flags2 = $|MF2_OBJECTFLIP
				mobj.eflags = $|MFE_VERTICALFLIP
			end
			
			-- Flash player after being hit. (From SRB2 source code)
			
			if (mobj.tracer.player.powers[pw_flashing] > 0 and mobj.tracer.player.powers[pw_flashing] < flashingtics
			and (leveltime & 1) and mobj.tracer.player.playerstate == PST_LIVE)
			or (not mobj.tracer.player.acehealth and mobj.tracer.issucked)
				mobj.flags2 = $|MF2_DONTDRAW
			else
				mobj.flags2 = $&~MF2_DONTDRAW
			end
			
			mobj.scale = mobj.tracer.scale
			
			-- Wings
			
			if not mobj.wings
				local wing1 = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_ACEFAIRY_WING)
				wing1.tracer = mobj
				wing1.i = 1
				
				local wing2 = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_ACEFAIRY_WING)
				wing2.tracer = mobj
				wing2.i = 2
				
				mobj.wings = {wing1, wing2}
			end
			
			-- Bubble
			
			if mobj.tracer.player.acehealth and (mobj.eflags & MFE_UNDERWATER)
				if mobj.bubble and mobj.bubble.valid
					P_MoveOrigin(mobj.bubble, mobj.x, mobj.y, mobj.z + (P_MobjFlip(mobj) < 0 and -mobj.height*2 - mobj.height/4 or mobj.height/4))
					
					if (mobj.bubble.flags2 & MF2_OBJECTFLIP) or (mobj.bubble.eflags & MFE_VERTICALFLIP)
						mobj.bubble.flags2 = $&~MF2_OBJECTFLIP
						mobj.bubble.eflags = $&~MFE_VERTICALFLIP
					end
				else
					mobj.bubble = P_SpawnMobjFromMobj(mobj, 0, 0, (P_MobjFlip(mobj) < 0 and -mobj.height*2 - mobj.height/4 or mobj.height/4), MT_ACEFAIRY_BUBBLE)
					mobj.bubble.tracer = mobj
					mobj.bubble.scale = mobj.scale
				end
			else
				if mobj.bubble and mobj.bubble.valid
					P_KillMobj(mobj.bubble)
				end
			end
		else
			if mobj.bubble and mobj.bubble.valid
				P_KillMobj(mobj.bubble)
			end
			
			P_RemoveMobj(mobj)
		end
	end
end, MT_ACEFAIRY)

addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid
		return false
	end
end, MT_ACEFAIRY)

addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid
		return false
	end
end, MT_ACEFAIRY_WING)

-- Fariy Wings

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.tracer and mobj.tracer.valid
			-- Thinker
			
			P_MoveOrigin(mobj, mobj.tracer.x, mobj.tracer.y, mobj.tracer.z + (P_MobjFlip(mobj) < 0 and -mobj.tracer.height/4 or mobj.tracer.height/2))
			
			local flapspeed
			if mobj.tracer.tracer.player.acehealth
				flapspeed = 2//FRACUNIT/3
			else
				if (leveltime & 128)
					flapspeed = 128//FRACUNIT/12
				else
					flapspeed = 64
				end
			end
			
			local wingangle = 0
			local newwingangle = 0
			if mobj.tracer.state != S_ACEFAIRY_ROLL and mobj.tracer.state != S_ACEFAIRY_PAIN
			and mobj.tracer.state != S_ACEFAIRY_DRWN and mobj.tracer.state != S_ACEFAIRY_DEAD
				if (leveltime & flapspeed)
					if mobj.tracer.tracer.player.acehealth
						newwingangle = ANGLE_90 - ANG15
					else
						newwingangle = ANGLE_45
					end
				else
					newwingangle = ANG15
				end
			else
				newwingangle = ANGLE_45
			end
			
			wingangle = newwingangle//ARTH_Ace.Ease(flapspeed, wingangle, newwingangle)
			
			if mobj.i == 1
				mobj.frame = $|FF_HORIZONTALFLIP
				mobj.angle = mobj.tracer.angle - wingangle
			else
				mobj.angle = mobj.tracer.angle + (wingangle - ANGLE_180)
			end
			
			-- Visual
			
			if (mobj.tracer.frame & FF_FULLBRIGHT)
				mobj.frame = $|FF_FULLBRIGHT
			else
				mobj.frame = $&~FF_FULLBRIGHT
			end
			
			if P_MobjFlip(mobj.tracer) > 0
				mobj.flags2 = $&~MF2_OBJECTFLIP
				mobj.eflags = $&~MFE_VERTICALFLIP
			else
				mobj.flags2 = $|MF2_OBJECTFLIP
				mobj.eflags = $|MFE_VERTICALFLIP
			end
			
			-- Flash player after being hit. (From SRB2 source code)
			
			if (mobj.tracer.flags2 & MF2_DONTDRAW)
				mobj.flags2 = $|MF2_DONTDRAW
			else
				mobj.flags2 = $&~MF2_DONTDRAW
			end
			
			mobj.scale = (mobj.tracer.scale*3)/4
			mobj.spritexscale = (FRACUNIT*3)/4
		else
			P_RemoveMobj(mobj)
		end
	end
end, MT_ACEFAIRY_WING)

-- Fariy Collect

local function FariyCollect(mobj, collectible)
	if mobj and mobj.valid and mobj.tracer and mobj.tracer.valid
	and collectible and collectible.valid
	and (ARTH_Ace.AceCollectible[collectible.type]
	and ARTH_Ace.AceCollectible[collectible.type][1])
		if mobj.target and collectible == mobj.target
		and (mobj.z <= collectible.z + collectible.height and mobj.z + mobj.height >= collectible.z)
		and collectible.health and not collectible.collected
			mobj.target = nil
			
			collectible.collected = true
			collectible.target = mobj.tracer
			collectible.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			S_StartSound(mobj, sfx_thok)
			return false
		end
	end
end

addHook("MobjCollide", FariyCollect, MT_ACEFAIRY)
addHook("MobjMoveCollide", FariyCollect, MT_ACEFAIRY)

local function CollectibleThinker(collectible)
	if collectible and collectible.valid and collectible.health
	and ARTH_Ace.AceCollectible[collectible.type]
		if collectible.target and collectible.collected
			A_HomingChase(collectible, 30*FRACUNIT+collectible.target.player.speed)
			
			if not collectible.health
				collectible.collected = false
				collectible.target = nil
				collectible.tracer = nil
			end
		end
	end
end

addHook("MobjThinker", CollectibleThinker)

freeslot("MT_ACESHIELD", "S_ACESHIELD_ON", "S_ACESHIELD", "S_ACESHIELD_OFF", "SPR_ASHD", "sfx_acepry")

-- Player Shield

mobjinfo[MT_ACESHIELD] =
{
	doomednum = -1,
	spawnstate = S_ACESHIELD,
	deathstate = S_ACESHIELD_OFF,
	//seesound = sfx_shield,
	//deathsound = sfx_ngskid,
	spawnhealth = 100,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = 1,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_ACESHIELD_ON] = {SPR_ASHD, 0, 0, nil, 0, 0, S_ACESHIELD}
states[S_ACESHIELD] = {SPR_ASHD, FF_ANIMATE|FF_FULLBRIGHT|FF_TRANS50, -1, nil, 9, 4}
states[S_ACESHIELD_OFF] = {SPR_ASHD, 0, 0, nil, 0, 0, S_NULL}

-- Parry Sound

sfxinfo[sfx_acepry].caption = "Magical Parry"
sfxinfo[sfx_acepry].flags = $|SF_X2AWAYSOUND

-- Shield Behavior

addHook("MobjThinker", function(shield)
	if shield and shield.valid
		if shield.tracer and shield.tracer.valid and shield.tracer.player.wiz
		and shield.tracer.player.wiz.fairy and shield.tracer.player.wiz.fairy.valid
			shield.color = R_GetColorByName(shield.tracer.player.wiz.fairy.color)
			
			local ShieldZ
			if P_MobjFlip(shield.tracer) > 0
				ShieldZ = shield.tracer.z + 2*FRACUNIT
				
				shield.flags2 = $&~MF2_OBJECTFLIP
				shield.eflags = $&~MFE_VERTICALFLIP
			else
				ShieldZ = shield.tracer.z - 2*FRACUNIT
				
				shield.flags2 = $|MF2_OBJECTFLIP
				shield.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(shield, shield.tracer.x, shield.tracer.y, ShieldZ)
			
			shield.angle = shield.tracer.player.drawangle
			shield.destscale = shield.tracer.player.shieldscale
		else
			P_RemoveMobj(shield)
		end
	end
end, MT_ACESHIELD)

local function ShieldCollide(shield, mobj)
	if not (shield and shield.valid and mobj and mobj.valid)
	or not ((mobj.flags & MF_ENEMY) or (mobj.flags & MF_MISSILE)
	or (mobj.flags & MF_PUSHABLE) or mobj.type == MT_ENERGYBALL
	or mobj.type == MT_HAMMER) or mobj == shield.tracer
	or mobj.tracer == shield.tracer or mobj.reflected
		return false
	end
	
	if mobj.z - mobj.scale <= shield.z + shield.height
	and mobj.z + mobj.height + mobj.scale >= shield.z
		local PushAngle = R_PointToAngle2(shield.tracer.x, shield.tracer.y, mobj.x, mobj.y)
		
		if shield.tracer.player.wiz.parry
			if not shield.parried
				S_StartSound(shield, sfx_s259)
			end
			
			if (mobj.flags & MF_MISSILE) or mobj.type == MT_ENERGYBALL or mobj.type == MT_HAMMER
				if not shield.parried
					S_StartSound(nil, sfx_acepry, shield.tracer.player)
					shield.parried = true
				end
				
				if not mobj.reflected
					local enemy = P_LookForEnemies(shield.tracer.player, false, true)
					
					if enemy and enemy.valid
						local targ
						if not mobj.target
							mobj.target = enemy
							targ = 0
						end
						
						if not mobj.tracer
							mobj.tracer = enemy
							targ = 1
						end
						
						A_HomingChase(mobj, 30*FRACUNIT, targ)
					else
						mobj.momx = -$
						mobj.momy = -$
						mobj.momz = -$
					end
					
					if mobj.target
						mobj.target = shield.tracer
					end
					
					if mobj.tracer
						mobj.tracer = shield.tracer
					end
					
					mobj.reflected = true
				end
				
				shield.tracer.player.wiz.parrytime = 4*TICRATE
				shield.tracer.player.wiz.fairymana = $+4
			end
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, shield.tracer.player.speed + PUSHACCEL*20)
			end
		else
			if shield.parried
				shield.parried = false
			end
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, ((mobj.flags & MF_PUSHABLE) and min(shield.tracer.player.speed + PUSHACCEL, mobjinfo[mobj.type].speed) or shield.tracer.player.speed + PUSHACCEL))
			end
		end
	end
end

addHook("MobjCollide", ShieldCollide, MT_ACESHIELD)
addHook("MobjMoveCollide", ShieldCollide, MT_ACESHIELD)

-- Player Protection

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.player.wiz
	and not (damagetype & DMG_DEATHMASK)
		if target.player.wiz.shield and not (damagetype and damagetype == DMG_NUKE)
		and target.player.wiz.shieldorb and target.player.wiz.shieldorb.valid
			return false
		end
	end
end, MT_PLAYER)