-- GUI

---- WIP HUD Text

local function wipRender(v, player)
	if player.mo and player.mo.valid and (player.mo.skin == "ace" or player.mo.skin == "draco" or (player.mo.skin == "kirby" and player.kvars.wiz))
		local YPosWIP
		if ARTH_Ace.AceHealth and ARTH_Ace.AceHealth.value
		and not (player.mo.skin == "kirby" and player.kvars.wiz)
			YPosWIP = 111
		else
			YPosWIP = 129
		end
		
		v.drawString(16, YPosWIP, ("Work in Progress!"),V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_REDMAP, "thin")
	end
end

hud.add(wipRender, "game")

---- Element Wheel

local function ElementWheel(v, player)
	if player.mo and player.wiz and not player.wiz.ondragon
	and player.powers[pw_carry] != CR_NIGHTSMODE and player.wiz.element != nil
		local ElementWheel = v.cachePatch("GUI_EWHEEL")
		
		v.drawScaled(-56*FRACUNIT, 108*FRACUNIT, FRACUNIT/2, ElementWheel, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		
		local EarthIcon = v.cachePatch("GUI_EARTH")
		local WaterIcon = v.cachePatch("GUI_WATER")
		local AirIcon = v.cachePatch("GUI_AIR")
		local FireIcon = v.cachePatch("GUI_FIRE")
		
		local XPosE, YPosE, XPosW, YPosW, XPosA, YPosA, XPosF, YPosF
		
		if player.wiz.element == 0
			player.wiz.ewnewangle = ANGLE_MAX
		elseif player.wiz.element == 1
			player.wiz.ewnewangle = ANGLE_90
		elseif player.wiz.element == 2
			player.wiz.ewnewangle = ANGLE_180
		elseif player.wiz.element == 3
			player.wiz.ewnewangle = ANGLE_270
		end
		
		player.wiz.ewangle = ARTH_Ace.Ease((player.wiz.ewangle < ANGLE_180 and FRACUNIT/3 or FRACUNIT), player.wiz.ewangle, player.wiz.ewnewangle)
		
		XPosE = -56*FRACUNIT + FixedMul(sin(player.wiz.ewangle + ANGLE_180), 14*FRACUNIT)
		YPosE = 108*FRACUNIT + FixedMul(cos(player.wiz.ewangle + ANGLE_180), 14*FRACUNIT)
		
		XPosW = -56*FRACUNIT + FixedMul(sin(player.wiz.ewangle + ANGLE_90), 14*FRACUNIT)
		YPosW = 108*FRACUNIT + FixedMul(cos(player.wiz.ewangle + ANGLE_90), 14*FRACUNIT)
		
		XPosA = -56*FRACUNIT + FixedMul(sin(player.wiz.ewangle), 14*FRACUNIT)
		YPosA = 108*FRACUNIT + FixedMul(cos(player.wiz.ewangle), 14*FRACUNIT)
		
		XPosF = -56*FRACUNIT + FixedMul(sin(player.wiz.ewangle + ANGLE_270), 14*FRACUNIT)
		YPosF = 108*FRACUNIT + FixedMul(cos(player.wiz.ewangle + ANGLE_270), 14*FRACUNIT)
		
		v.drawScaled(XPosE, YPosE, FRACUNIT/2, EarthIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		v.drawScaled(XPosW, YPosW, FRACUNIT/2, WaterIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		v.drawScaled(XPosA, YPosA, FRACUNIT/2, AirIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		v.drawScaled(XPosF, YPosF, FRACUNIT/2, FireIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
	end
end

hud.add(ElementWheel)

---- Match warning

local WarnTime = 6*TICRATE

local function AceMatchWarning(v, player)
	if WarnTime and (gametyperules & GTR_RINGSLINGER)
		if player.mo and player.mo.valid and (player.mo.skin == "ace" or (player.mo.skin == "kirby" and player.kvars.wiz))
			WarnTime = $-1
			
			v.drawString(160, 192, ("Hold 'TOSS FLAG' to switch elements."), V_HUDTRANS|V_PURPLEMAP, "small-center")
		end
	else
		return
	end
end

hud.add(AceMatchWarning)

addHook("MapLoad", function() WarnTime = 6*TICRATE end)

---- Mana Bar

local function AceManaBar(v, player)
	if player.mo and player.wiz and player.powers[pw_carry] != CR_NIGHTSMODE
	and (player.wiz.mana != nil or player.wiz.fairymana != nil)
		local ManaBar = v.cachePatch("GUI_MANABAR")
		
		local CastFill = v.cachePatch("GUI_MANABAR_FILL")
		local ShieldFill = v.cachePatch("GUI_MANABAR_FILL")
		
		local XPosC = -61
		local XPosS = -61
		
		local YPosH
		if ARTH_Ace.AceHealth and ARTH_Ace.AceHealth.value
		and not (player.mo.skin == "kirby" and player.kvars.wiz)
			YPosH = -18
		else
			YPosH = 0
		end
		
		local MobjColor
		if player.wiz.ondragon and player.wiz.dragon and player.wiz.dragon.valid
			MobjColor = player.wiz.dragon.color
		else
			MobjColor = player.skincolor
		end
		
		local Color
		if not G_GametypeHasTeams()
			Color = R_GetColorByName(MobjColor+15)
		else
			Color = R_GetColorByName(MobjColor)
		end
		
		if player.wiz.mana != nil and not player.wiz.ondragon
			v.draw(-110, -19 + YPosH, ManaBar, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			
			for i = 98, 1, -1
				if player.wiz.mana >= i
					v.draw(XPosC, -22 + YPosH, CastFill, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_CERULEAN", player.mo.color))
				end
				XPosC = $-1
			end
		end
		
		if player.wiz.fairymana != nil and player.wiz.fairy
			v.draw(-110, -10 + YPosH, ManaBar, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			
			for i = 98, 1, -1
				if player.wiz.fairymana >= i
					v.draw(XPosS, -13 + YPosH, ShieldFill, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_PURPLE", Color))
				end
				XPosS = $-1
			end
		end
	end
end

hud.add(AceManaBar)

---- Healing Flowers

local function HealingFlowers(v, player)
	if player.hellfireHealth return end
	
	if player.mo and (player.mo.skin == "ace" or player.mo.skin == "draco")
	and player.powers[pw_carry] != CR_NIGHTSMODE and player.acehealth != nil
	and ARTH_Ace.AceHealth and ARTH_Ace.AceHealth.value
		local HealingFlower = v.cachePatch("GUI_HFLOWER")
		
		local Color
		if player.mo.skin == "ace"
			local MobjColor
			if player.wiz and player.wiz.ondragon and player.wiz.dragon and player.wiz.dragon.valid
				MobjColor = player.wiz.dragon.color
			else
				MobjColor = player.skincolor
			end
			
			if not G_GametypeHasTeams()
				Color = R_GetColorByName(MobjColor+15)
			else
				Color = R_GetColorByName(MobjColor)
			end
		else
			Color = SKINCOLOR_PURPLE
		end
		
		if player.mo.health
			if player.acehealth >= 0
				v.drawScaled(-72*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_PURPLE", Color))
			end
			
			if player.acehealth >= 1
				v.drawScaled(-55*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_PURPLE", Color))
			end
			
			if player.acehealth >= 2
				v.drawScaled(-38*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_PURPLE", Color))
			end
			
			if player.acehealth >= 3
				v.drawScaled(-21*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_PURPLE", Color))
			end
			
			if player.acehealth == 4
				v.drawScaled(-4*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_PURPLE", Color))
			end
		end
	end
end

if not srb2p and not pso
	hud.add(HealingFlowers)
end

---- Wizard Journal

/*local function WizardJournal(v, player)
	if player.wiz and (player.wiz.journal.active or player.wiz.journal.time)
		v.drawString(160, 30, "SIMPLE MENU", 0, "center")
	end
end

if not pso
	hud.add(WizardJournal)
end*/