-- Tables

---- Collectibles collectable by the fairy

/*ARTH_Ace.AceCollectible[name] = {collectable, pointable}

name: -- The name of the collectible.
collectable: -- If true, the fairy will collect it. If false, the fairy won't collect it.
pointable: -- If true, the fairy will point at it. If false, the fairy won't point at it.*/

if not ARTH_Ace.AceCollectible
	rawset(ARTH_Ace, "AceCollectible", {})
end

ARTH_Ace.AceCollectible[MT_RING] = {true, true}
ARTH_Ace.AceCollectible[MT_FLINGRING] = {true, true}
ARTH_Ace.AceCollectible[MT_COIN] = {true, true}
ARTH_Ace.AceCollectible[MT_FLINGCOIN] = {true, true}

ARTH_Ace.AceCollectible[MT_TOKEN] = {true, true}
ARTH_Ace.AceCollectible[MT_BLUESPHERE] = {true, true}

//ARTH_Ace.AceCollectible[MT_EMBLEM] = {false, true}

ARTH_Ace.AceCollectible[MT_EMERALD1] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD2] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD3] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD4] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD5] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD6] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD7] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERHUNT] = {false, true}

/*ARTH_Ace.AceCollectible[MT_RING_BOX] = {false, true}
ARTH_Ace.AceCollectible[MT_1UP_BOX] = {false, true}
ARTH_Ace.AceCollectible[MT_SCORE1K_BOX] = {false, true}
ARTH_Ace.AceCollectible[MT_SCORE10K_BOX] = {false, true}*/

ARTH_Ace.AceCollectible[MT_FLINGNIGHTSCHIP] = {true, true}
ARTH_Ace.AceCollectible[MT_FLINGNIGHTSSTAR] = {true, true}

ARTH_Ace.AceCollectible[MT_INFINITYRING] = {true, true}
ARTH_Ace.AceCollectible[MT_BOUNCERING] = {true, true}
ARTH_Ace.AceCollectible[MT_RAILRING] = {true, true}
ARTH_Ace.AceCollectible[MT_AUTOMATICRING] = {true, true}
ARTH_Ace.AceCollectible[MT_EXPLOSIONRING] = {true, true}
ARTH_Ace.AceCollectible[MT_SCATTERRING] = {true, true}
ARTH_Ace.AceCollectible[MT_GRENADERING] = {true, true}

ARTH_Ace.AceCollectible[MT_BOUNCEPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_RAILPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_AUTOPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_EXPLODEPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_SCATTERPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_GRENADEPICKUP] = {true, true}

-- Functions

---- Custom ease interpolation

rawset(ARTH_Ace, "Ease", function(t, s, e)
	return s + FixedMul(e - s, t/2)
end)

---- Healing for Ace's Health System

/*ARTH_Ace.AceHeal(player, sound)

player: -- The player.
sound: -- If true or nil, it will play the healing sound. If false, it won't play the healing sound.*/

if not ARTH_Ace.AceHeal
	rawset(ARTH_Ace, "AceHeal", function(player, sound) 
		if player and player.valid and player.acehealth != nil
		and (player.mo.skin == "ace" or player.mo.skin == "draco")
		and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.powers[pw_carry] != CR_NIGHTSFALL
			if player.acehealth < 4
				player.acehealth = $+1
				
				if player.wiz
					if player.wiz.fairy and player.wiz.fairy.valid
						player.wiz.fairy.health = player.acehealth
					end
					
					if player.wiz.dragon and player.wiz.dragon.valid
						player.wiz.dragon.health = player.acehealth
					end	
				end
				
				if sound != false
					S_StartSound(special, sfx_hoop1)
				end
			end
		end
	end)
end

/*ARTH_Ace.SpawnFlower(mobj, player, target)

mobj: -- The object you're spawning the flower from.
player: -- The player.
target: -- If true, it will home in on the player. If false or nil, it won't home in on the player.*/

if not ARTH_Ace.SpawnFlower
	rawset(ARTH_Ace, "SpawnFlower", function(mobj, player, target)
		local Flower = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ACEFLOWER)
		
		if P_MobjFlip(mobj) > 0
			Flower.flags2 = $&~MF2_OBJECTFLIP
			Flower.eflags = $&~MFE_VERTICALFLIP
		else
			Flower.flags2 = $|MF2_OBJECTFLIP
			Flower.eflags = $|MFE_VERTICALFLIP
		end
		
		if target
			Flower.target = player.mo
		end
	end)
end

---- Mana for Ace's Mana System

/*ARTH_Ace.GainMana(mobj, player, amount)

mobj: -- The object you're spawning the flower from.
player: -- The player.
amount: -- The amount of Mana you want to give. (100 is the max amount.)*/

if not ARTH_Ace.GainMana
	rawset(ARTH_Ace, "GainMana", function(mobj, player, amount)
		if amount > 100
			amount = 100
		end
		
		for i = 1, amount
			local Mana = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_ACEMANA)
			
			if Mana and Mana.valid
				Mana.target = player.mo
				
				Mana.color = Mana.target.color
				Mana.frame = FF_FULLBRIGHT|FF_TRANS50
			end
		end
	end)
end

-- Commands

local OnOff = "On" if srb2p or pso OnOff = "Off" end

---- Ace's Health System

if not ARTH_Ace.AceHealth
	rawset(ARTH_Ace, "AceHealth", CV_RegisterVar({
		name = "acehealth",
		defaultvalue = OnOff,
		flags = CV_NETVAR|CV_CALL,
		PossibleValue = CV_OnOff,
		func = function(cv)
			if not srb2p and not pso
				if cv.value
					print("\x84\Ace's Health System is on.")
				else
					print("\x84\Ace's Health System is off.")
				end
			else
				print("\x85\Ace's Health System doesn't work here.")
			end
		end
	}))
end

---- Sasha's Fetch Modes

if not ARTH_Ace.FetchMode
	rawset(ARTH_Ace, "FetchMode", CV_RegisterVar({
		name = "fetchmode",
		defaultvalue = "2",
		flags = CV_NETVAR|CV_CALL,
		func = function(cv)
			if cv.value == 1
				print("\x89\Sasha can now fetch objects in platformer gametypes.")
			elseif cv.value == 2
				print("\x89\Sasha can now fetch objects in platformer and match gametypes.")
			elseif cv.value == 3
				print("\x89\Sasha can now fetch objects in platformer and match gametypes, and special stages.")
			elseif not cv.value
				print("\x85\Sasha can no longer fetch objects.")
			end
			
			if cv.value > 3
				CONS_Printf(consoleplayer, "There's no mode beyond 3.")
			end
		end
	}))
end

---- Ace's Tips

/*if not ARTH_Ace.AceTips
	rawset(ARTH_Ace, "AceTips", CV_RegisterVar({
		name = "acetips",
		defaultvalue = OnOff,
		flags = CV_NETVAR|CV_CALL,
		PossibleValue = CV_OnOff,
		func = function(cv)
			if not srb2p and not pso
				if cv.value
					print("\x89\Ace's Tips is on.")
				else
					print("\x89\Ace's Tips is off.")
				end
			else
				print("\x85\Ace's Tips doesn't work here.")
			end
		end
	}))
end*/