-- Buttons

local A = BT_JUMP
local B = BT_CUSTOM2
local X = BT_USE|BT_SPIN if srb2p X = BT_CUSTOM3 end
local Y = BT_CUSTOM3 if srb2p Y = 0 end
local LB = BT_WEAPONPREV
local RB = BT_WEAPONNEXT
local LT = BT_CUSTOM1|BT_FIRENORMAL
local RT = BT_ATTACK
local BACK = BT_TOSSFLAG

addHook("ThinkFrame", function(player)
	for player in players.iterate
		if player.realmo.skin == "ace" or player.realmo.skin == "draco"
		or (player.realmo.skin == "kirby" and player.kvars.wiz)
			if not (player.cmd.buttons & A)
				player.atapready = true
				player.atap = false
			elseif player.atapready then
				player.atap = true
				player.atapready = false
			else
				player.atap = false
			end
			
			if not (player.cmd.buttons & B)
				player.btapready = true
				player.btap = false
			elseif player.btapready then
				player.btap = true
				player.btapready = false
			else
				player.btap = false
			end
			
			if not (player.cmd.buttons & X)
				player.xtapready = true
				player.xtap = false
			elseif player.xtapready then
				player.xtap = true
				player.xtapready = false
			else
				player.xtap = false
			end
			
			if not (player.cmd.buttons & Y)
				player.ytapready = true
				player.ytap = false
			elseif player.ytapready then
				player.ytap = true
				player.ytapready = false
			else
				player.ytap = false
			end
			
			if not (player.cmd.buttons & LT)
				player.lttapready = true
				player.lttap = false
			elseif player.lttapready then
				player.lttap = true
				player.lttapready = false
			else
				player.lttap = false
			end
			
			if not (player.cmd.buttons & RT)
				player.rttapready = true
				player.rttap = false
			elseif player.rttapready then
				player.rttap = true
				player.rttapready = false
			else
				player.rttap = false
			end
			
			if not (player.cmd.buttons & BACK)
				player.backtapready = true
				player.backtap = false
			elseif player.backtapready then
				player.backtap = true
				player.backtapready = false
			else
				player.backtap = false
			end
		end
	end
end)

---- Switch elements without switching weapons

addHook("PreThinkFrame", function(player)
	for player in players.iterate
		if player.realmo.skin == "ace"
		or (player.realmo.skin == "kirby" and player.kvars.wiz)
			if not (player.cmd.buttons & LB)
				player.lbtapready = true
				player.lbtap = false
			elseif player.lbtapready then
				player.lbtap = true
				player.lbtapready = false
			else
				player.lbtap = false
			end
			
			if not (player.cmd.buttons & RB)
				player.rbtapready = true
				player.rbtap = false
			elseif player.rbtapready then
				player.rbtap = true
				player.rbtapready = false
			else
				player.rbtap = false
			end
			
			if (player.cmd.buttons & BACK)
				if (player.cmd.buttons & LB)
					player.cmd.buttons = $&~LB
				end
				
				if (player.cmd.buttons & RB)
					player.cmd.buttons = $&~RB
				end
			end
		end
	end
end)

-- Camera

local camera
local firstperson = false

hud.add(function(v, player, realcamera)
	camera = realcamera
	
	if realcamera.chase
		firstperson = false
	else
		firstperson = true
	end
end, "game")

-- Player Spawn

local function AceInit(player)
	if player.mo and player.mo.valid and player.mo.skin == "ace"
		player.wiz =
		{element = 0,
		ewangle = 0,
		ewnewangle = 0,
		mana = 100,
		casting = false,
		castaim = 0,
		castangle = 0,
		castrecharge = false,
		castdelay = 0,
		castcarry = false,
		castcarrymobj = nil,
		shield = false,
		fairymana = 100,
		shieldrecharge = false,
		shielddelay = 0,
		parry = false,
		parrytime = 2,
		jumpability = false,
		jumpabilitytime = 0,
		jumpabilitydelay = 0,
		crouching = false,
		forcecrouch = false,
		sliding = false,
		slidejump = 0,
		slidetime = 0,
		forceslide = false,
		sprinting = false,
		diving = false,
		divedelay = 0,
		divetime = 0,
		wall = nil,
		wallsliding = false,
		wallslidetime = 0,
		walljump = 0,
		wallbonk = 0,
		swimming = false}
		
		player.acehealth = 3
	end
end

addHook("PlayerSpawn", function(player)
	AceInit(player)
end)

addHook("BotRespawn", function(player)
	AceInit(player)
end)

-- Elemental Jump Abilities

---- Boulder Lift

local function BoulderLift(player)
	if player.mo.valid and player.mo.skin == "ace"
		if not player.wiz.jumpability return end
		
		if not (player.wiz.boulder and player.wiz.boulder.valid
		and player.wiz.boulder.tracer and player.wiz.boulder.tracer.valid)
			player.wiz.mana = max($-25, 0)
			
			player.wiz.boulder = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEBOULDER)
			player.wiz.boulder.tracer = player.mo
			player.wiz.boulder.scale = (player.mo.scale*3)/2
			
			S_StartSound(player.mo, sfx_s3k49)
		else
			if (player.cmd.buttons & A) or player.wiz.jumpabilitytime <= 10
				P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
			else
				P_SetObjectMomZ(player.mo, FixedMul(12*FRACUNIT, player.mo.scale))
				S_StartSound(player.mo, sfx_jump)
			end
		end
	end
end

addHook("MobjThinker", function(boulder)
	if boulder and boulder.valid
		if boulder.tracer and boulder.tracer.valid
			local BoulderZ
			if P_MobjFlip(boulder.tracer) > 0
				BoulderZ = boulder.tracer.z - boulder.tracer.height/4
				
				boulder.flags2 = $&~MF2_OBJECTFLIP
				boulder.eflags = $&~MFE_VERTICALFLIP
			else
				BoulderZ = boulder.tracer.z + boulder.tracer.height/2
				
				boulder.flags2 = $|MF2_OBJECTFLIP
				boulder.eflags = $|MFE_VERTICALFLIP
			end
			
			P_SlideMove(boulder)
			
			local MomZ
			if boulder.tracer.player.wiz.jumpability
				MomZ = boulder.tracer.momz
				
				P_TryMove(boulder, boulder.tracer.x + FixedMul(cos(boulder.tracer.player.drawangle), 30*FRACUNIT),
				boulder.tracer.y + FixedMul(sin(boulder.tracer.player.drawangle), 30*FRACUNIT), true)
				boulder.z = BoulderZ
				
				boulder.angle = boulder.tracer.player.drawangle
				
				boulder.flags = $|MF_NOGRAVITY
			else
				MomZ = boulder.momz
				
				if not boulder.fuse
					boulder.momx = boulder.tracer.player.rmomx
					boulder.momy = boulder.tracer.player.rmomy
					P_SetObjectMomZ(boulder, -10*FRACUNIT)
					
					boulder.fuse = 1*TICRATE
					
					boulder.flags = $&~MF_NOGRAVITY
				end
			end
			
			if MomZ * P_MobjFlip(boulder) <= -15*FRACUNIT
			and ((boulder.z + MomZ < boulder.floorz and not (boulder.eflags & MFE_VERTICALFLIP))
			or (boulder.z + boulder.height + boulder.momz > boulder.ceilingz and (boulder.eflags & MFE_VERTICALFLIP)))
				S_StartSound(boulder, sfx_pstop)
				
				for i = 1, 16
					local Dust = P_SpawnMobjFromMobj(boulder, 0, 0, 0, (boulder.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)) and MT_MEDIUMBUBBLE or MT_SPINDUST)
					
					Dust.target = boulder.tracer
					Dust.fuse = TICRATE
					Dust.scale = boulder.scale
					Dust.destscale = boulder.scale/8
					
					P_InstaThrust(Dust, i*ANGLE_22h, 20*FRACUNIT)
					
					Dust.flags = $|MF_MISSILE&~MF_NOCLIP
				end
			end
			
			for fof in boulder.subsector.sector.ffloors()
				if not (fof.flags & FF_EXISTS) continue end
				if not (fof.flags & FF_BUSTUP) continue end
				
				if boulder.z + MomZ + boulder.height < fof.bottomheight continue end
				if boulder.z + MomZ > fof.topheight continue end
				
				EV_CrumbleChain(fof)
			end
		end
	end
end, MT_ACEBOULDER)

---- Bubble Jump

local function BubbleJump(player)
	if player.mo.valid and player.mo.skin == "ace"
		if not player.wiz.jumpability return end
		
		player.wiz.mana = max($-2, 0)
		
		if player.wiz.bubble and player.wiz.bubble.valid
			player.powers[pw_underwater] = underwatertics
			player.powers[pw_spacetime] = spacetimetics
		else
			player.mo.flags = $|MF_NOGRAVITY
			
			P_SetObjectMomZ(player.mo, FixedMul(2*FRACUNIT, player.mo.scale), true)
			
			player.wiz.bubble = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEBUBBLE)
			player.wiz.bubble.tracer = player.mo
			player.wiz.bubble.scale = FRACUNIT/4
			player.wiz.bubble.scalespeed = FRACUNIT/4
			
			S_StartSound(player.mo, sfx_splash)
		end
	end
end

addHook("MobjThinker", function(bubble)
	if bubble and bubble.valid
		if bubble.tracer and bubble.tracer.valid
			local BubbleZ
			if P_MobjFlip(bubble.tracer) > 0
				BubbleZ = bubble.tracer.z + 2*FRACUNIT
				
				bubble.flags2 = $&~MF2_OBJECTFLIP
				bubble.eflags = $&~MFE_VERTICALFLIP
			else
				BubbleZ = bubble.tracer.z - 2*FRACUNIT - bubble.tracer.height/4
				
				bubble.flags2 = $|MF2_OBJECTFLIP
				bubble.eflags = $|MFE_VERTICALFLIP
			end
			
			if bubble.tracer.player.wiz.jumpability
				P_MoveOrigin(bubble, bubble.tracer.x, bubble.tracer.y, BubbleZ)
				
				bubble.angle = bubble.tracer.player.drawangle
				bubble.destscale = bubble.tracer.player.shieldscale
			else
				S_StartSound(bubble.tracer, sfx_s3k77)
				P_KillMobj(bubble)
			end
		else
			P_RemoveMobj(bubble)
		end
	end
end, MT_ACEBUBBLE)

---- Cloud Surf

local function CloudSurf(player)
	if player.mo.valid and player.mo.skin == "ace"
		if not player.wiz.jumpability S_StopSound(player.mo, sfx_s3kcel) return end
		
		if player.wiz.cloud and player.wiz.cloud.valid
			player.acceleration = skins[player.mo.skin].acceleration*2
			
			if player.wiz.cloud.scale > FRACUNIT/4
				player.drawangle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
			end
			
			if not S_SoundPlaying(player.mo, sfx_s3kcel)
				S_StartSound(player.mo, sfx_s3kcel)
			end
			
			player.wiz.jumpabilityloop = true
			
			if FixedHypot(player.mo.momx, player.mo.momy) < 20*FRACUNIT
				P_InstaThrust(player.mo, player.drawangle, FixedMul(20*FRACUNIT, player.mo.scale))
			end
			
			if not player.powers[pw_carry]
				if player.mo.momz * P_MobjFlip(player.mo) > FRACUNIT*2
					P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
				elseif player.mo.momz * P_MobjFlip(player.mo) < -3*FRACUNIT
					P_SetObjectMomZ(player.mo, FRACUNIT*2, true)
				else
					P_SetObjectMomZ(player.mo, -2*FRACUNIT)
				end
			end
			
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, -player.height/2 - player.height/6, MT_THOK)
			
			Thok.color = SKINCOLOR_CLOUDY
			Thok.scalespeed = FRACUNIT/8
			Thok.destscale = 0
		else
			player.wiz.mana = max($-25, 0)
		
			player.wiz.cloud = P_SpawnMobjFromMobj(player.mo, 0, 0, -player.height, MT_ACECLOUD)
			player.wiz.cloud.tracer = player.mo
			player.wiz.cloud.scale = FRACUNIT/4
			player.wiz.cloud.scalespeed = FRACUNIT/4
			
			S_StartSound(player.mo, sfx_wdjump)
		end
	end
end

addHook("MobjThinker", function(cloud)
	if cloud and cloud.valid
		if cloud.tracer and cloud.tracer.valid
			local CloudZ
			if P_MobjFlip(cloud.tracer) > 0
				CloudZ = cloud.tracer.z - cloud.tracer.height/2
				
				cloud.flags2 = $&~MF2_OBJECTFLIP
				cloud.eflags = $&~MFE_VERTICALFLIP
			else
				CloudZ = cloud.tracer.z + cloud.tracer.height/2 + cloud.tracer.height/4
				
				cloud.flags2 = $|MF2_OBJECTFLIP
				cloud.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(cloud, cloud.tracer.x, cloud.tracer.y, CloudZ)
			
			cloud.angle = cloud.tracer.player.drawangle
			
			if cloud.tracer.player.wiz.jumpability
				cloud.destscale = cloud.tracer.player.shieldscale
			else
				if not S_SoundPlaying(cloud.tracer, sfx_wdjump)
					S_StartSound(cloud.tracer, sfx_wdjump)
				end
				
				cloud.destscale = 0
				
				if cloud.scale <= FRACUNIT/96
					P_KillMobj(cloud)
				end
			end
		else
			P_RemoveMobj(cloud)
		end
	end
end, MT_ACECLOUD)

---- Flame Dash

local function FlameDash(player)
	if player.mo.valid and player.mo.skin == "ace"
		if not player.wiz.jumpability return end
		
		player.wiz.mana = max($-2, 0)
		
		if player.wiz.fireball and player.wiz.fireball.valid
			player.acceleration = (skins[player.mo.skin].acceleration*3)/2
			
			if player.wiz.fireball.scale > FRACUNIT/4
				player.drawangle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
			end
			
			player.charflags = $|SF_CANBUSTWALLS
			
			if FixedHypot(player.mo.momx, player.mo.momy) < 40*FRACUNIT
				P_InstaThrust(player.mo, player.drawangle, FixedMul(40*FRACUNIT, player.mo.scale))
			end
			
			if not player.powers[pw_carry]
				if player.mo.momz * P_MobjFlip(player.mo) > FRACUNIT*4
					P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
				elseif player.mo.momz * P_MobjFlip(player.mo) < -FRACUNIT
					P_SetObjectMomZ(player.mo, FRACUNIT*2, true)
				else
					P_SetObjectMomZ(player.mo, 0)
				end
			end
			
			local ThokZ
			if P_MobjFlip(player.mo) > 0
				ThokZ = 0
			else
				ThokZ = player.height/2
			end
			
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, ThokZ, MT_THOK)
			
			Thok.color = SKINCOLOR_FLAME
			Thok.frame = $|FF_FULLBRIGHT
			Thok.scale = (player.mo.scale*3)/2
			Thok.scalespeed = FRACUNIT/4
			Thok.destscale = 0
		else
			player.wiz.fireball = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEFIREBALL)
			player.wiz.fireball.tracer = player.mo
			player.wiz.fireball.scale = FRACUNIT/4
			player.wiz.fireball.scalespeed = FRACUNIT/4
			
			S_StartSound(player.mo, sfx_s1b3)
		end
	end
end

addHook("MobjThinker", function(fireball)
	if fireball and fireball.valid
		if fireball.tracer and fireball.tracer.valid
			local FireballZ
			if P_MobjFlip(fireball.tracer) > 0
				FireballZ = fireball.tracer.z + 2*FRACUNIT
				
				fireball.flags2 = $&~MF2_OBJECTFLIP
				fireball.eflags = $&~MFE_VERTICALFLIP
			else
				FireballZ = fireball.tracer.z - fireball.tracer.height/4
				
				fireball.flags2 = $|MF2_OBJECTFLIP
				fireball.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(fireball, fireball.tracer.x, fireball.tracer.y, FireballZ)
			
			fireball.angle = fireball.tracer.player.drawangle
			
			if fireball.tracer.player.wiz.jumpability
				fireball.destscale = fireball.tracer.player.shieldscale
			else
				if fireball.scale == FRACUNIT
					fireball.tracer.momx = $/2
					fireball.tracer.momy = $/2
				end
				
				if not S_SoundPlaying(fireball.tracer, sfx_s1ae)
					S_StartSound(fireball.tracer, sfx_s1ae)
				end
				
				fireball.destscale = 0
				
				if fireball.scale <= FRACUNIT/96
					P_KillMobj(fireball)
				end
			end
		else
			P_RemoveMobj(fireball)
		end
	end
end, MT_ACEFIREBALL)

-- Element Raycast

addHook("MobjThinker", function(ray)
	if ray and ray.valid
		if not ray.tracer
			P_RemoveMobj(ray)
		end
	end
end, MT_ACERAY)

-- Activate Jump Ability

---- While Falling

addHook("JumpSpecial", function(player)
	if player.mo.skin != "ace" or (player.wiz and ((player.wiz.banstate
	and not player.wiz.walljump) or player.wiz.diving or player.wiz.wallsliding)
	or player.wiz.castcarry) or (player.cc_tricksenabled and player.mo.momz * P_MobjFlip(player.mo) > 0)
	or player.powers[pw_carry] or player.powers[pw_super] return end
	
	if player.mo and not (player.pflags & PF_JUMPED) and player.atap
		if not P_IsObjectInGoop(player.mo) and not (player.mo.eflags & MFE_UNDERWATER)
			if not player.wiz.jumpability and not player.wiz.jumpabilitydelay
			and player.wiz.mana >= 25 and not player.powers[pw_pushing]
				if (player.mo.z - player.mo.height/4 + player.mo.momz > player.mo.floorz and not (player.mo.eflags & MFE_VERTICALFLIP))
				or (player.mo.z + player.mo.height + player.mo.height/4 + player.mo.momz < player.mo.ceilingz and (player.mo.eflags & MFE_VERTICALFLIP))
					player.wiz.jumpability = true
				end
			end
		else
			if not player.wiz.swimming
				player.wiz.swimming = true
			end
		end
	end
	
	if (player.pflags & PF_SPINNING)
		player.pflags = $&~PF_SPINNING
	end
end)

---- While Jumping

addHook("AbilitySpecial", function(player)
	if player.mo.skin != "ace" or (player.wiz and ((player.wiz.banstate
	and not player.wiz.walljump) or player.wiz.diving or player.wiz.wallsliding)
	or player.wiz.castcarry) or (player.cc_tricksenabled and player.mo.momz * P_MobjFlip(player.mo) > 0)
	or player.powers[pw_carry] or player.powers[pw_super] return end
	
	if player.mo
		if not P_IsObjectInGoop(player.mo) and not (player.mo.eflags & MFE_UNDERWATER)
			if not player.wiz.jumpability and not player.wiz.jumpabilitydelay
			and player.wiz.mana >= 25 and not player.powers[pw_pushing]
				if (player.mo.z - player.mo.height/2 + player.mo.momz > player.mo.floorz and not (player.mo.eflags & MFE_VERTICALFLIP))
				or (player.mo.z + player.mo.height + player.mo.height/2 + player.mo.momz < player.mo.ceilingz and (player.mo.eflags & MFE_VERTICALFLIP))
					player.wiz.jumpability = true
				end
			end
		else
			if not player.wiz.swimming
				player.wiz.swimming = true
			end
		end
	end
	
	if (player.pflags & PF_SPINNING)
		player.pflags = $&~PF_SPINNING
	end
end)

-- Vars Check

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.mo and player.wiz and player.mo.skin != "ace"
		and (player.mo.skin != "draco" or not player.wiz.ondragon)
		and (player.mo.skin != "kirby" or not player.kvars.wiz)
			player.wiz = nil -- You are not worthy to use the wand...
		end
	end
end)

-- Player Think

addHook("PlayerThink", function(player)
	if player.mo and player.wiz
	and (player.mo.skin == "ace" or player.wiz.ondragon)
		local TwoD = twodlevel or (player.mo.flags2 & MF2_TWOD)
		
		-- Natural --
		
		-- Crouch and Slide
		
		if player.wiz.slidetime != nil
			if player.mo.standingslope and P_IsObjectOnGround(player.mo)
				player.wiz.slidetime = min($+1, 100)
			elseif not P_IsObjectOnGround(player.mo)
				player.wiz.slidetime = 0
			else
				if player.wiz.slidetime
					player.wiz.slidetime = $-1
				end
			end
		end
		
		if ((((player.btap and not player.wiz.crouching) or ((player.cmd.buttons & B) and player.wiz.crouching)
		or ((player.cmd.buttons & X) and player.wiz.diving and player.speed >= FixedMul(10*FRACUNIT, player.mo.scale))
		or (TwoD and player.cmd.forwardmove < -20 and not player.mo.currentaxis) or player.wiz.sliding)
		and player.mo.state != S_PLAY_SKID) or player.wiz.forcecrouch or player.wiz.forceslide)
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player) and not player.wiz.banstate
		and P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo) and player.powers[pw_carry] != CR_FAN
			player.height = P_GetPlayerSpinHeight(player)
			
			local SlideSpeed
			if player.powers[pw_sneakers] or player.powers[pw_super]
				if player.gotflag
					SlideSpeed = ((skins[player.mo.skin].normalspeed*5)/2)
				else
					SlideSpeed = ((skins[player.mo.skin].normalspeed*5)/2)+5
				end
			else
				if player.gotflag
					SlideSpeed = ((skins[player.mo.skin].normalspeed*3)/2)
				else
					SlideSpeed = ((skins[player.mo.skin].normalspeed*3)/2)+5
				end
			end
			
			if player.speed <= FixedMul(11*FRACUNIT, player.mo.scale) or player.wiz.castcarry
				player.wiz.sliding = false
				player.wiz.crouching = true
				
				player.normalspeed = skins[player.mo.skin].normalspeed/2
				player.acceleration = skins[player.mo.skin].acceleration
				
				player.pflags = $&~PF_SPINNING
				
				if player.xtap and not player.wiz.sliding and not player.wiz.castcarry
					P_InstaThrust(player.mo, player.drawangle, FixedMul(SlideSpeed, player.mo.scale))
					
					player.pflags = $|PF_SPINNING
					player.wiz.crouching = false
					player.wiz.sliding = true
				end
			elseif player.speed > FixedMul(11*FRACUNIT, player.mo.scale) and not player.wiz.castcarry
				player.wiz.crouching = false
				player.wiz.forcecrouch = false
				
				if not player.wiz.diving
					player.wiz.sliding = true
				end
				
				if player.wiz.diving
					player.pflags = $|PF_JUMPSTASIS
				end
				
				if not (player.pflags & PF_SPINNING)
					P_InstaThrust(player.mo, player.drawangle, FixedMul(SlideSpeed, player.mo.scale))
					
					player.pflags = $|PF_SPINNING
				end
				
				if not player.wiz.slidetime and (not player.mo.standingslope or (player.mo.standingslope.flags & SL_NOPHYSICS))
					P_Thrust(player.mo, player.drawangle, FixedMul(-player.mo.friction/4 + FixedMul(abs(player.cmd.sidemove), player.acceleration), player.mo.scale))
				elseif player.mo.standingslope and not (player.mo.standingslope.flags & SL_NOPHYSICS)
					P_Thrust(player.mo, player.mo.standingslope.xydirection, player.mo.standingslope.zdelta * P_MobjFlip(player.mo) * 2)
				end
				
				player.acceleration = skins[player.mo.skin].acceleration*10
				
				P_SpawnSkidDust(player, player.mo.radius, true)
			end
			
			if player.mo.state == S_PLAY_STND
			or player.mo.state == S_PLAY_WAIT
				player.mo.state = S_PLAY_STND
			end
		else
			if player.wiz.sliding
				player.pflags = $&~PF_SPINNING
			end
			
			player.wiz.crouching = false
			
			if player.wiz.sliding and not P_IsObjectOnGround(player.mo)
				if (player.pflags & PF_JUMPED)
					player.wiz.slidejump = 15
				end
				
				player.wiz.sliding = false
			end
			
			if not player.wiz.diving and not player.wiz.swimming
				player.height = skins[player.mo.skin].height
			end
			
			if not player.wiz.jumpability and not player.wiz.wallslide
				player.acceleration = skins[player.mo.skin].acceleration
			end
			
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.slidejump
			player.wiz.slidejump = 0
		end
		
		if player.wiz.slidejump
			player.wiz.slidejump = $-1
		end
		
		-- Ceiling Height Check
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and player.mo.ceilingz - player.mo.floorz < FixedMul(skins[player.mo.skin].height, player.mo.scale)
			if player.speed <= FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.forcecrouch = true
			elseif player.speed > FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.forceslide = true
			end
		else
			player.wiz.forcecrouch = false
			player.wiz.forceslide = false
		end
		
		-- Sliping -- This is scrapped too.
		
		-- Sprint
		
		if ((((player.cmd.buttons & X) or player.machspeedmode)
		and P_IsObjectOnGround(player.mo)) or player.wiz.swimming
		or player.powers[pw_sneakers] or player.powers[pw_super])
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.banstate and not player.wiz.crouching
		and not player.wiz.sliding and not player.wiz.diving and not player.wiz.wallsliding
			player.wiz.sprinting = true
			
			if player.powers[pw_sneakers] and (player.cmd.buttons & X)
				if P_IsObjectOnGround(player.mo)
					if player.gotflag
						player.normalspeed = (skins[player.mo.skin].normalspeed*5)/2
					else
						player.normalspeed = ((skins[player.mo.skin].normalspeed*5)/2)+5
					end
					
					player.charflags = $|SF_DASHMODE|SF_RUNONWATER
					
					if player.speed >= FixedMul(player.runspeed, player.mo.scale) -- Totally Radical! (From SRB2 source code)
						if player.dashmode < 3*TICRATE
							player.dashmode = 3*TICRATE
							S_StartSound(player.mo, sfx_rail1)
						end
					else
						player.dashmode = max($-3, 0)
					end
				end
			else
				if player.gotflag
					player.normalspeed = (skins[player.mo.skin].normalspeed*3)/2
				else
					player.normalspeed = ((skins[player.mo.skin].normalspeed*3)/2)+5
				end
				
				player.charflags = $&~SF_DASHMODE
				
				if not player.powers[pw_sneakers]
					player.dashmode = 0
				end
				
				if not player.machspeedmode
					player.charflags = $&~SF_RUNONWATER
				end
			end
			
			if player.machspeedmode
				player.charflags = $|SF_RUNONWATER
			end
			
			player.thrustfactor = skins[player.mo.skin].thrustfactor*2
		else
			player.wiz.sprinting = false
			
			if not player.wiz.wallsliding and not player.wiz.swimming
			and not player.wiz.crouching and not player.wiz.sliding and not player.wiz.diving
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.thrustfactor = skins[player.mo.skin].thrustfactor
			end
			
			player.dashmode = 0
			player.charflags = $&~SF_DASHMODE
			
			if not player.machspeedmode
				player.charflags = $&~SF_RUNONWATER
			end
		end
		
		if player.mo.state == S_PLAY_DASH and player.dashmode < 3*TICRATE
			player.mo.state = S_PLAY_RUN
		end
		
		-- Fist Slam -- This is scrapped because of the Boulder Lift.
		
		-- Dive
		
		if player.xtap and not player.wiz.diving and not player.wiz.divedelay
		and not P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_SPRUNG)
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and (not player.powers[pw_carry] or player.powers[pw_carry] == CR_FAN)
		and not player.powers[pw_super] and not player.wiz.banstate
		and not player.gotflag and not player.wiz.jumpability
		and not player.wiz.wallsliding and not player.wiz.crouching
		and not player.wiz.sliding and not player.wiz.castcarry
			player.wiz.diving = true
			player.wiz.divetime = 15
			
			player.height = P_GetPlayerSpinHeight(player)
			player.pflags = $|PF_DRILLING
			
			local DiveSpeed
			if player.powers[pw_sneakers] or player.powers[pw_super]
				if player.gotflag
					DiveSpeed = ((skins[player.mo.skin].normalspeed*5)/2)
				else
					DiveSpeed = ((skins[player.mo.skin].normalspeed*5)/2)+5
				end
				
				S_StartSound(player.mo, sfx_rail1)
			else
				if player.gotflag
					DiveSpeed = ((skins[player.mo.skin].normalspeed*3)/2)
				else
					DiveSpeed = ((skins[player.mo.skin].normalspeed*3)/2)+5
				end
				
				S_StartSound(player.mo, sfx_thok)
			end
			
			P_InstaThrust(player.mo, player.drawangle, FixedMul(DiveSpeed, player.mo.scale))
			
			if not player.wiz.swimming
				P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
			end
			
			for i = 1, 16
				local Dust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, (player.mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)) and MT_MEDIUMBUBBLE or MT_SPINDUST)
				
				Dust.target = player.mo
				Dust.fuse = TICRATE
				Dust.scale = player.mo.scale
				Dust.destscale = player.mo.scale/8
				
				P_InstaThrust(Dust, i*ANGLE_22h, 20*FRACUNIT)
			end
		elseif (((not (player.cmd.buttons & X) or player.speed <= FixedMul(11*FRACUNIT, player.mo.scale))
		and P_IsObjectOnGround(player.mo)) or (player.atap and not P_IsObjectOnGround(player.mo)
		and not player.wiz.swimming and not player.wiz.divetime) or P_IsObjectInGoop(player.mo)
		or ((player.mo.eflags & MFE_SPRUNG) and not player.wiz.slidetime) or P_InQuicksand(player.mo))
		or player.playerstate != PST_LIVE or P_PlayerInPain(player) or player.wiz.banstate
		or player.wiz.crouching or player.wiz.sliding or (player.powers[pw_carry] and player.powers[pw_carry] != CR_FAN)
		or ((player.wiz.swimming or player.powers[pw_carry] == CR_FAN) and not player.wiz.divetime)
			if player.wiz.diving
				if (player.wiz.swimming and not player.wiz.divetime)
					player.mo.momx = $/2
					player.mo.momy = $/2
				end
				
				if (P_IsObjectOnGround(player.mo) and not player.wiz.crouching and not player.wiz.sliding)
				or (player.atap and not P_IsObjectOnGround(player.mo) and not player.wiz.divetime)
					P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), not P_IsObjectOnGround(player.mo))
				end
				
				if not player.wiz.banstate
					player.wiz.divedelay = 30
				end
				
				player.wiz.diving = false
				player.pflags = $&~PF_DRILLING&~PF_JUMPSTASIS&~PF_SPINNING
			end
			
			if not player.wiz.diving and not player.wiz.crouching and not player.wiz.sliding and not player.wiz.swimming
				player.height = skins[player.mo.skin].height
			end
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.divetime
			player.wiz.divetime = 0
		end
		
		if player.wiz.divetime
			player.wiz.divetime = $-1
		end
		
		if P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.wiz.divedelay and player.wiz.divedelay <= 29
			player.wiz.divedelay = 0
		end
		
		if player.wiz.divedelay
			player.wiz.divedelay = $-1
		end
		
		-- Swimming
		
		if player.wiz.swimming and (P_IsObjectInGoop(player.mo) or (player.mo.eflags & MFE_UNDERWATER))
		and player.playerstate == PST_LIVE and (not P_PlayerInPain(player) or player.mo.state == S_PLAY_STUN)
		and not P_IsObjectOnGround(player.mo) and (not player.wiz.banstate or player.wiz.wallbonk) and not player.powers[pw_super]
			if (P_GetPlayerControlDirection(player) == 1 and abs(player.speed) >= FRACUNIT)
			or ((player.cmd.buttons & A|B) and abs(player.mo.momz) >= FRACUNIT)
				player.height = P_GetPlayerSpinHeight(player)
			else
				player.height = skins[player.mo.skin].height
			end
			
			if (player.powers[pw_super] or player.powers[pw_sneakers] or player.wiz.sprinting) -- Set the player speeds. (From SRB2 source code)
				player.acceleration = player.accelstart/2 + (FixedDiv(player.speed, player.mo.scale)>>FRACBITS) * player.acceleration/2
			else
				player.acceleration = player.accelstart + (FixedDiv(player.speed, player.mo.scale)>>FRACBITS) * player.acceleration
			end
			
			if (player.cmd.buttons & A)
				if player.mo.momz * P_MobjFlip(player.mo) < player.normalspeed/2
					P_SetObjectMomZ(player.mo, 4800*player.thrustfactor, true)
				end
			elseif (player.cmd.buttons & B)
				if player.mo.momz * P_MobjFlip(player.mo) > -player.normalspeed/2
					P_SetObjectMomZ(player.mo, -2400*player.thrustfactor, true)
				end
			end
			
			if not P_IsObjectInGoop(player.mo) and not player.powers[pw_carry]
				if player.mo.momz * P_MobjFlip(player.mo) > FRACUNIT*2
				and not (player.cmd.buttons & A)
					P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
				elseif player.mo.momz * P_MobjFlip(player.mo) < -FRACUNIT
				and not (player.cmd.buttons & B)
					P_SetObjectMomZ(player.mo, FRACUNIT, true)
				elseif not (player.cmd.buttons & A) and not (player.cmd.buttons & B)
					P_SetObjectMomZ(player.mo, 0)
				end
			end
			
			if player.mo.momz * P_MobjFlip(player.mo) >= 11*FRACUNIT/2
			and ((player.mo.z + player.mo.height/2 + player.mo.momz > player.mo.watertop and not (player.mo.eflags & MFE_VERTICALFLIP))
			or (player.mo.z - player.mo.height/2 + player.mo.momz < player.mo.waterbottom and (player.mo.eflags & MFE_VERTICALFLIP)))
				P_SetObjectMomZ(player.mo, 11*FRACUNIT/2 * P_MobjFlip(player.mo))
			end
			
			if player.backtap or (player.cmd.buttons & BACK) and player.droptime <= 9
				if player.droptime
					player.droptime = $-1
				else
					player.wiz.swimming = false
				end
			else
				player.droptime = 10
			end
		else
			player.wiz.swimming = false
		end
		
		-- Wall Movement
		
		if player.wiz.wall and player.wiz.wall.valid and player.wiz.wall.special != 41
		and not (player.wiz.wall.flags & ML_NOCLIMB) and (player.cmd.buttons & X) and (not player.atap or (player.pflags & PF_STARTJUMP))
		and not P_IsObjectOnGround(player.mo) and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and (not player.wiz.banstate or player.wiz.walljump) and not player.wiz.jumpability and not player.wiz.swimming
			if player.wiz.diving
				player.wiz.diving = false
			end
			
			if player.wiz.walljump
				player.wiz.walljump = 0
			end
			
			if not player.wiz.wallsliding
				player.wiz.wallsliding = true
				
				S_StartSound(player.mo, sfx_s3k4a)
				
				P_ReturnThrustX(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), player.mo.momx)
				P_ReturnThrustY(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), player.mo.momy)
			end
			
			player.drawangle = player.wiz.wallnormal + ANGLE_180
			player.wiz.castangle = player.wiz.wallnormal + ANGLE_180
			
			P_SpawnSkidDust(player, player.mo.radius, true)
			
			if not player.powers[pw_pushing]
				if player.wiz.wallslidetime
					P_Thrust(player.mo, player.wiz.wallnormal, FixedMul(4*FRACUNIT, player.mo.scale))
					
					player.wiz.wallslidetime = $-1
				else
					player.wiz.wallsliding = false
					player.wiz.wall = nil
					
					player.accelstart = skins[player.mo.skin].accelstart
					
					player.wiz.wallslidetime = 2
				end
			else
				player.wiz.wallslidetime = 2
			end
			
			P_ReturnThrustX(player.mo, player.wiz.wallnormal, player.mo.momx)
			P_ReturnThrustY(player.mo, player.wiz.wallnormal, player.mo.momy)
			
			if player.mo.momz * P_MobjFlip(player.mo) >= FRACUNIT*16
				P_SetObjectMomZ(player.mo, FixedMul(FRACUNIT*16, player.mo.scale))
			elseif player.mo.momz * P_MobjFlip(player.mo) <= -FRACUNIT*16
				P_SetObjectMomZ(player.mo, FixedMul(-FRACUNIT*16, player.mo.scale))
			end
		elseif (not (player.cmd.buttons & X) or player.atap) and player.wiz.wallsliding
			player.wiz.wallsliding = false
			player.wiz.wall = nil
			
			if player.atap
				player.wiz.walljump = 25
				
				player.mo.angle = player.wiz.wallnormal + ANGLE_180
				
				P_Thrust(player.mo, player.wiz.wallnormal, FixedMul(-20*FRACUNIT, player.mo.scale))
				P_SetObjectMomZ(player.mo, FixedMul(10*FRACUNIT, player.mo.scale))
				S_StartSound(player.mo, sfx_jump)
			end
		else
			player.wiz.wallsliding = false
			player.wiz.wall = nil
		end
		
		if P_IsObjectOnGround(player.mo)
			player.wiz.wallslidedelay = 10
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.walljump
			player.wiz.walljump = 0
		end
		
		if player.wiz.walljump
			player.wiz.walljump = $-1
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.wallbonk
			player.wiz.wallbonk = 0
		end
		
		if player.wiz.wallbonk
			player.wiz.wallbonk = $-1
		end
		
		-- Magic --
		
		-- Jump Ability
		
		if player.wiz.jumpability and player.wiz.mana and not player.wiz.wallsliding
		and not player.wiz.swimming and not P_PlayerInPain(player) and player.playerstate == PST_LIVE
		and not (player.mo.eflags & MFE_UNDERWATER) and not player.wiz.divedelay
		and not player.wiz.diving and not player.wiz.banstate
			local ElementObject
			if player.wiz.element == 0
				BoulderLift(player)
				
				if player.wiz.boulder and player.wiz.boulder.valid
					ElementObject = player.wiz.boulder
				end
			elseif player.wiz.element == 1
				BubbleJump(player)
				
				if player.wiz.bubble and player.wiz.bubble.valid
					ElementObject = player.wiz.bubble
				end
			elseif player.wiz.element == 2
				CloudSurf(player)
				
				if player.wiz.cloud and player.wiz.cloud.valid
					ElementObject = player.wiz.cloud
				end
			elseif player.wiz.element == 3
				FlameDash(player)
				
				if player.wiz.fireball and player.wiz.fireball.valid
					ElementObject = player.wiz.fireball
				end
			end
			
			player.wiz.jumpabilitytime = min($+1, 15)
			
			player.mo.eflags = $&~MFE_JUSTHITFLOOR&~MFE_ONGROUND
			
			if ElementObject and ElementObject.valid
				if ElementObject.ray and ElementObject.ray.valid
					if not (ElementObject.ray.eflags & MFE_UNDERWATER)
						if not (player.mo.eflags & MFE_VERTICALFLIP)
							P_MoveOrigin(ElementObject.ray, player.mo.x, player.mo.y, ElementObject.z - ElementObject.height/2)
						else
							P_MoveOrigin(ElementObject.ray, player.mo.x, player.mo.y, ElementObject.z + ElementObject.height + ElementObject.height/4)
						end
					else
						if not (player.mo.eflags & MFE_VERTICALFLIP)
							P_MoveOrigin(ElementObject.ray, player.mo.x, player.mo.y, ElementObject.ray.watertop - ElementObject.ray.height)
						else
							P_MoveOrigin(ElementObject.ray, player.mo.x, player.mo.y, ElementObject.ray.waterbottom - ElementObject.ray.height/4)
						end
					end
				else
					ElementObject.ray = P_SpawnMobjFromMobj(player.mo, 0, 0, ElementObject.z - ElementObject.height/2, MT_ACERAY)
					ElementObject.ray.tracer = ElementObject
				end
				
				if (((player.mo.floorrover and player.mo.floorrover.valid) or (player.mo.subsector.sector.floorpic != skyflatnum
				and player.mo.subsector.sector.special != 6 and player.mo.subsector.sector.special != 7))
				and ElementObject.z - ElementObject.height/6 + player.mo.momz <= player.mo.floorz and not (player.mo.eflags & MFE_VERTICALFLIP)
				and (not (ElementObject.ray.eflags & MFE_UNDERWATER) or ElementObject.ray.watertop < player.mo.floorz))
				or (((player.mo.ceilingrover and player.mo.ceilingrover.valid) or player.mo.subsector.sector.ceilingpic != skyflatnum)
				and ElementObject.z + ElementObject.height + ElementObject.height/6 + player.mo.momz >= player.mo.ceilingz and (player.mo.eflags & MFE_VERTICALFLIP)
				and (not (ElementObject.ray.eflags & MFE_UNDERWATER) or ElementObject.ray.waterbottom > player.mo.ceilingz))
					if player.wiz.element != 0 and player.wiz.element != 2
						if not (player.mo.eflags & MFE_VERTICALFLIP)
							player.mo.z = player.mo.floorz + ElementObject.height/8
						else
							player.mo.z = player.mo.ceilingz - ElementObject.height + ElementObject.height/16
						end
					else
						player.wiz.banstate = true
					end
					
					if player.wiz.element == 1
						if abs(player.mo.momz) >= 10*FRACUNIT
							P_SetObjectMomZ(player.mo, -player.mo.momz/2 - FRACUNIT)
							S_StartSound(ElementObject, sfx_s3k44)
							
							player.wiz.mana = min($+10, 100)
						else
							P_SetObjectMomZ(player.mo, 0)
						end
					end
				elseif (player.wiz.element == 1 or player.wiz.element == 3)
				and ((((player.mo.ceilingrover and player.mo.ceilingrover.valid) or player.mo.subsector.sector.ceilingpic != skyflatnum)
				and ElementObject.z + ElementObject.height + ElementObject.height/2 + player.mo.momz >= player.mo.ceilingz and not (player.mo.eflags & MFE_VERTICALFLIP)
				and (not (ElementObject.ray.eflags & MFE_UNDERWATER) or ElementObject.ray.waterbottom > player.mo.ceilingz))
				or (((player.mo.floorrover and player.mo.floorrover.valid) or (player.mo.subsector.sector.floorpic != skyflatnum
				and player.mo.subsector.sector.special != 6 and player.mo.subsector.sector.special != 7))
				and ElementObject.z - ElementObject.height/2 + ElementObject.height/16 + player.mo.momz <= player.mo.floorz and (player.mo.eflags & MFE_VERTICALFLIP)
				and (not (ElementObject.ray.eflags & MFE_UNDERWATER) or ElementObject.ray.watertop < player.mo.floorz)))
					if not (player.mo.eflags & MFE_VERTICALFLIP)
						player.mo.z = player.mo.ceilingz - ElementObject.height - ElementObject.height/2
					else
						player.mo.z = player.mo.floorz + ElementObject.height - ElementObject.height/3
					end
					
					if player.wiz.element == 1
						if abs(player.mo.momz) >= 10*FRACUNIT
							P_SetObjectMomZ(player.mo, -player.mo.momz/2 - FRACUNIT)
							S_StartSound(ElementObject, sfx_s3k44)
							
							player.wiz.mana = min($+10, 100)
						else
							P_SetObjectMomZ(player.mo, 0)
						end
					end
				elseif (ElementObject.ray.eflags & MFE_UNDERWATER)
				and ((ElementObject.z - ElementObject.height/(player.wiz.element != 2 and 6 or 1)
				+ player.mo.momz <= ElementObject.ray.watertop and not (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.floorz <= ElementObject.ray.watertop)
				or (ElementObject.z + ElementObject.height + ElementObject.height/(player.wiz.element != 2 and 6 or 1)
				+ player.mo.momz >= ElementObject.ray.waterbottom and (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.ceilingz >= ElementObject.ray.waterbottom))
					if player.wiz.element == 0
						local splishtype = (ElementObject.ray.eflags & MFE_TOUCHLAVA) and MT_LAVASPLISH or MT_SPLISH -- (From SRB2 source code)
						local water = P_SpawnMobj(player.mo.x, player.mo.y, ((player.mo.eflags & MFE_VERTICALFLIP)
						and ElementObject.ray.waterbottom - FixedMul(mobjinfo[splishtype].height, player.mo.scale) or ElementObject.ray.watertop), splishtype)
						
						if (ElementObject.ray.eflags & MFE_GOOWATER)
							S_StartSound(water, sfx_ghit)
						elseif (ElementObject.ray.eflags & MFE_TOUCHLAVA)
							S_StartSound(water, sfx_splash)
						else
							S_StartSound(water, sfx_splish)
						end
						
						if (player.mo.eflags & MFE_VERTICALFLIP)
							water.flags2 = $|MF2_OBJECTFLIP
							water.eflags = $|MFE_VERTICALFLIP
						end
						
						water.destscale = player.mo.scale
						P_SetScale(water, player.mo.scale)
						
						-- skipping stone!
						if abs(player.speed) >= 10*FRACUNIT and abs(player.mo.momz) >= 5*FRACUNIT and player.speed/2 > abs(player.mo.momz)
							P_Thrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), -player.speed/8)
							P_SetObjectMomZ(player.mo, -player.mo.momz)
						else
							player.wiz.banstate = true
						end
					else
						if not (player.mo.eflags & MFE_VERTICALFLIP)
							player.mo.z = ElementObject.ray.watertop + ElementObject.height/(player.wiz.element != 2 and 8 or 1)
						else
							player.mo.z = ElementObject.ray.waterbottom - ElementObject.height*(player.wiz.element != 2 and 1 or 2)
						end
						
						if abs(player.mo.momz) < 10*FRACUNIT
							P_SetObjectMomZ(player.mo, 0)
						end
					end
				end
			end
		end
		
		if (player.wiz.jumpability and ((not player.wiz.mana or (not (player.cmd.buttons & A) and player.wiz.jumpabilitytime > 11
		and player.wiz.element == 0) or (player.wiz.jumpabilitytime >= 15 and player.atap) or P_IsObjectInGoop(player.mo)
		or P_InQuicksand(player.mo)) or P_PlayerInPain(player) or player.playerstate != PST_LIVE or (player.mo.eflags & MFE_UNDERWATER)))
		or player.powers[pw_carry] or player.wiz.banstate or player.wiz.divedelay
			player.wiz.jumpability = false
			player.wiz.jumpabilitytime = 0
			
			if not player.wiz.banstate and not player.wiz.slidejump and not player.wiz.divedelay
				player.wiz.jumpabilitydelay = 50
			elseif player.wiz.divedelay
				player.wiz.jumpabilitydelay = 25
			elseif (player.wiz.banstate and not player.wiz.slidejump and not player.wiz.walljump)
				player.wiz.jumpabilitydelay = 15
			else
				player.wiz.jumpabilitydelay = 0
			end
			
			if player.wiz.jumpabilityloop
				player.wiz.jumpabilityloop = false
			end
			
			player.mo.flags = $&~MF_NOGRAVITY&~MF_BOUNCE
			
			player.charflags = $&~SF_CANBUSTWALLS
			
			player.height = skins[player.mo.skin].height
			
			if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and not P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_SPRUNG)
			and player.wiz.element != 0 and not player.wiz.banstate
			and not player.wiz.slidejump and not player.wiz.divedelay
				P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
			end
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.jumpabilitydelay
			player.wiz.jumpabilitydelay = 0
		end
		
		if player.wiz.jumpabilitydelay
			player.wiz.jumpabilitydelay = $-1
		end
		
		-- Switch Element
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player) and not player.wiz.jumpability
		and (not player.wiz.banstate or player.wiz.slidejump or player.wiz.walljump
		or (player.wiz.divedelay and not player.wiz.diving)) and not player.wiz.casting
		and (not (gametyperules & GTR_RINGSLINGER) or (player.cmd.buttons & BACK))
			if player.lbtap
				player.wiz.element = $-1
				
				S_StartSound(nil, sfx_tink, player)
			elseif player.rbtap
				player.wiz.element = $+1
				
				S_StartSound(nil, sfx_tink, player)
			end
		end
		
		if player.wiz.element < 0
			player.wiz.element = 3
		elseif player.wiz.element > 3
			player.wiz.element = 0
		end
		
		-- Cast
		
		if not player.wiz.wallsliding
			player.wiz.castangle = player.drawangle
		end
		
		if (player.cmd.buttons & RT) and player.playerstate == PST_LIVE
		and not P_PlayerInPain(player) and not player.wiz.banstate
		and player.mo.state != S_PLAY_ROLL and not (player.wiz.wallsliding
		and P_GetPlayerControlDirection(player) == 1) and not player.wiz.jumpability
		and not player.wiz.sliding and player.dashmode <= 3*TICRATE
		and not player.wiz.diving and not player.wiz.castrecharge
		and not player.wiz.shield and not (gametyperules & GTR_RINGSLINGER)
		and (not (player.mo.eflags & MFE_UNDERWATER)
		or (player.wiz.element == 0 or player.wiz.element == 2))
			if player.wiz.mana
				player.wiz.casting = true
				
				if not player.wiz.castcarry
					player.wiz.mana = $-1
				end
				
				if player.wiz.castdelay
					player.wiz.castdelay = $-1
				end
				
				if player.wiz.element == 0 and player.wiz.castdelay == 0
					local Rock = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.wiz.castangle, mobjinfo[MT_ACEEARTH].speed),
					player.mo.y + P_ReturnThrustY(nil, player.wiz.castangle, mobjinfo[MT_ACEEARTH].speed),
					player.mo.z + player.height/2, MT_ACEEARTH,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/2)
					
					if Rock and Rock.valid
						Rock.scale = FRACUNIT/4
						Rock.scalespeed = FRACUNIT/4
						Rock.destscale = FRACUNIT
						Rock.tracer = player.mo
					end
					
					player.wiz.castdelay = 5
				elseif player.wiz.element == 1
					local Water = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.wiz.castangle, mobjinfo[MT_ACEWATER].speed),
					player.mo.y + P_ReturnThrustY(nil, player.wiz.castangle, mobjinfo[MT_ACEWATER].speed),
					player.mo.z + player.height/2, MT_ACEWATER,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/2)
					
					if Water and Water.valid
						Water.scale = FRACUNIT/2
						Water.scalespeed = FRACUNIT/8
						Water.destscale = FRACUNIT
						Water.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_splish)
					end
				elseif player.wiz.element == 2
					local Wind = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.wiz.castangle, mobjinfo[MT_ACEAIR].speed),
					player.mo.y + P_ReturnThrustY(nil, player.wiz.castangle, mobjinfo[MT_ACEAIR].speed),
					player.mo.z + player.height/2, MT_ACEAIR,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/2)
					
					if Wind and Wind.valid
						Wind.scale = FRACUNIT/2
						Wind.scalespeed = FRACUNIT/8
						Wind.destscale = FRACUNIT
						Wind.tracer = player.mo
						
						if not S_SoundPlaying(player.mo, sfx_s3kces)
							S_StartSound(player.mo, sfx_s3kces)
						end
					end
					
					if player.wiz.castcarrymobj and player.wiz.castcarrymobj.valid
						if (player.wiz.castcarrymobj.flags & MF_ENEMY)
							player.wiz.castcarrymobj.wasenemy = true
							player.wiz.castcarrymobj.flags = $&~MF_ENEMY
						end
						
						if (player.wiz.castcarrymobj.flags & MF_SPECIAL)
							player.wiz.castcarrymobj.wasspecial = true
							player.wiz.castcarrymobj.flags = $&~MF_SPECIAL
						end
						
						local movespeed
						local dist = P_AproxDistance(P_AproxDistance(player.wiz.castcarrymobj.x - player.mo.x,
						player.wiz.castcarrymobj.y - player.mo.y), player.wiz.castcarrymobj.z - player.mo.z)
						if (dist >= 0 and dist < 512*player.mo.scale)
							movespeed = FRACUNIT/3
						else
							movespeed = FRACUNIT
						end
						
						P_TryMove(player.wiz.castcarrymobj,
						ARTH_Ace.Ease(FRACUNIT/3, player.wiz.castcarrymobj.x, player.mo.x + FixedMul(cos(player.drawangle),
						player.mo.radius + mobjinfo[player.wiz.castcarrymobj.type].radius + 150*FRACUNIT)) + player.rmomx,
						ARTH_Ace.Ease(FRACUNIT/3, player.wiz.castcarrymobj.y, player.mo.y + FixedMul(sin(player.drawangle),
						player.mo.radius + mobjinfo[player.wiz.castcarrymobj.type].radius + 150*FRACUNIT)) + player.rmomy, true)
						player.wiz.castcarrymobj.z = ARTH_Ace.Ease(FRACUNIT/3, player.wiz.castcarrymobj.z, player.mo.z + player.mo.height)
						
						P_SlideMove(player.wiz.castcarrymobj)
						
						P_InstaThrust(player.wiz.castcarrymobj, player.wiz.castcarrymobj.angle, 0)
						P_SetObjectMomZ(player.wiz.castcarrymobj, 0)
					else
						player.wiz.castcarry = false
						player.wiz.castcarrymobj = nil
					end
				elseif player.wiz.element == 3
					local Flame = P_SpawnPointMissile(player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.wiz.castangle, mobjinfo[MT_ACEFIRE].speed),
					player.mo.y + P_ReturnThrustY(nil, player.wiz.castangle, mobjinfo[MT_ACEFIRE].speed),
					player.mo.z + player.height/2, MT_ACEFIRE,
					player.mo.x,
					player.mo.y,
					player.mo.z + player.height/2)
					
					if Flame and Flame.valid
						Flame.scale = FRACUNIT/2
						Flame.scalespeed = FRACUNIT/8
						Flame.destscale = FRACUNIT
						Flame.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_fire)
					end
				end
			else
				player.wiz.castrecharge = true
			end
			
			if player.mo.state == S_PLAY_STND
			or player.mo.state == S_PLAY_WAIT
				player.mo.state = S_PLAY_STND
			end
		else
			player.wiz.casting = false
			player.wiz.castdelay = 0
			
			if player.wiz.castcarry and player.wiz.castcarrymobj and player.wiz.castcarrymobj.valid
				player.wiz.castcarry = false
				player.wiz.castcarrymobj = nil
			end
		end
		
		if player.rttap and player.wiz.castrecharge
			player.wiz.castrecharge = false
		end
		
		if (not player.wiz.casting and not player.wiz.jumpability) or player.wiz.banstate
			player.wiz.mana = min($+1, 100)
		end
		
		-- State Machine
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			if player.wiz.jumpability and player.wiz.element == 0
				player.mo.state = S_PLAY_ACEBOULDERLIFT
				
				if not srb2p
					player.powers[pw_strong] = STR_BOUNCE|STR_SPRING|STR_HEAVY
				end
			elseif player.wiz.jumpability and player.wiz.element == 1
				player.mo.state = S_PLAY_ACEBUBBLEJUMP
			elseif player.wiz.jumpability and player.wiz.element == 2
				player.mo.state = S_PLAY_ACECLOUDSURF
			elseif player.wiz.jumpability and player.wiz.element == 3
				player.mo.state = S_PLAY_ACEFLAMEDASH
			elseif player.wiz.wallsliding or player.wiz.walljump >= 14
				if not P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_CLING
					
					if player.wiz.walljump and not player.wiz.wallsliding
						player.mo.state = S_PLAY_JUMP
					end
				else
					player.mo.state = S_PLAY_STND
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			elseif player.wiz.wallbonk and not P_IsObjectOnGround(player.mo)
				if player.mo.state != S_PLAY_STUN
					player.mo.state = S_PLAY_STUN
					player.mo.tics = player.wiz.wallbonk
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			elseif player.wiz.swimming
				if player.wiz.diving
					player.mo.state = S_PLAY_ACEDIVE
				else
					if (P_GetPlayerControlDirection(player) == 1 and abs(player.speed) >= FRACUNIT)
					or (((player.cmd.buttons & A) or (player.cmd.buttons & B)) and abs(player.mo.momz) >= FRACUNIT)
						if player.mo.state != S_PLAY_SWIM
							player.mo.state = S_PLAY_SWIM
						end
					else
						player.mo.state = S_PLAY_FALL
					end
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			elseif player.dashmode > 3*TICRATE
				if not srb2p
					player.powers[pw_strong] = STR_METAL
				end
			elseif (player.wiz.diving or player.wiz.divedelay)
			and not player.wiz.swimming
				if not player.wiz.divedelay
					player.mo.state = S_PLAY_ACEDIVE
					
					if not srb2p
						player.powers[pw_strong] = STR_ANIM|STR_PUNCH
					end
				elseif player.wiz.divedelay >= 29 and not player.powers[pw_carry]
					player.mo.state = S_PLAY_ACEDIVE_UNDIVE
					
					if not srb2p
						player.powers[pw_strong] = STR_NONE
					end
				end
			elseif player.wiz.sliding or player.wiz.slidejump >= 14
				if not player.wiz.slidejump
					player.mo.state = S_PLAY_ACESLIDE
					
					if not srb2p
						player.powers[pw_strong] = STR_ANIM|STR_PUNCH
					end
				else
					player.mo.state = S_PLAY_ACESLIDE_JUMP
					
					if not srb2p
						player.powers[pw_strong] = STR_NONE
					end
				end
			else
				if not player.powers[pw_justlaunched] and not P_IsObjectOnGround(player.mo)
					if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK
					or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_DASH
					or player.mo.state == S_PLAY_ACECROUCH or player.mo.state == S_PLAY_ACECRAWL
					or player.mo.state == S_PLAY_CLING)
					and player.powers[pw_carry] == CR_NONE and not (player.pflags & PF_SPINNING)
						player.mo.state = S_PLAY_FALL
					end
				elseif player.powers[pw_justlaunched] and not P_IsObjectOnGround(player.mo)
				and not (player.pflags & PF_JUMPED|PF_SPINNING)
					player.mo.state = S_PLAY_SPRING
				end
				
				if player.powers[pw_carry] == CR_FAN or player.powers[pw_carry] == CR_DUSTDEVIL
					if player.mo.state != S_PLAY_GLIDE
						player.mo.state = S_PLAY_GLIDE
					end
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			end
		end
		
		if (player.mo.state == S_PLAY_EDGE
		or player.mo.state == S_PLAY_ACESLIDE_JUMP
		or player.mo.state == S_PLAY_ACEDIVE_UNDIVE
		or (player.mo.state == S_PLAY_ROLL
		and P_IsObjectOnGround(player.mo))) or pso
		or player.powers[pw_carry] == CR_ZOOMTUBE
		or player.powers[pw_carry] == CR_NIGHTSMODE
		or player.powers[pw_carry] == CR_SUNSTARGRAB
		or player.mo.issucked or player.exiting or player.wiz.ondragon
		or player.wiz.wallbonk or player.wiz.walljump
		or player.mo.frostburnt or player.frozen or player.dirk_frozen
		or (player.eggride and player.eggride.state)
			player.wiz.banstate = true
		else
			player.wiz.banstate = false
		end
	else
		AceInit(player)
	end
end)

-- Cast Sprites

local CASTSPRITES = {
	[SPR2_STND] = SPR2_FIRE,
	[SPR2_WALK] = SPR2_FWLK,
	[SPR2_RUN_] = SPR2_FRUN,
	[SPR2_JUMP] = SPR2_FJMP,
	[SPR2_SPNG] = SPR2_FJMP,
	[SPR2_FALL] = SPR2_FAIR,
	[SPR2_RIDE] = SPR2_FRID,
	[SPR2_GLID] = SPR2_FGLD,
	[SPR2_CLNG] = SPR2_FCNG,
	[SPR2_SWIM] = SPR2_FSWM
}

-- Pre Frame

addHook("PreThinkFrame", function()
	for player in players.iterate
		if player.mo and player.mo.prestate
			if player.mo.skin == "ace" and player.mo.state == player.mo.prestate
				player.mo.sprite2 = player.mo.presprite2
				player.mo.frame = player.mo.preframe
			end
			
			player.mo.prestate = nil
		end
	end
end)

-- Post Frame

addHook("PostThinkFrame", function()
	for player in players.iterate
		if player.realmo.skin == "ace" and player.wiz
			if (player.wiz.casting and CASTSPRITES[player.mo.sprite2])
			or (player.wiz.crouching and (player.mo.sprite2 == SPR2_STND or player.mo.sprite2 == SPR2_WALK))
				player.mo.prestate = player.mo.state
				player.mo.presprite2 = player.mo.sprite2
				player.mo.preframe = player.mo.frame
				
				if player.wiz.casting and CASTSPRITES[player.mo.sprite2]
				and not player.wiz.crouching
					player.mo.sprite2 = CASTSPRITES[player.mo.sprite2]
				elseif player.wiz.crouching
					if player.mo.sprite2 == SPR2_STND
						if player.wiz.casting
							player.mo.sprite2 = SPR2_FCRH
						else
							player.mo.sprite2 = SPR2_CRCH
						end
					elseif player.mo.sprite2 == SPR2_WALK
						if player.wiz.casting
							player.mo.sprite2 = SPR2_FCRL
						else
							player.mo.sprite2 = SPR2_CRWL
						end
					end
				end
				
				player.mo.frame = player.mo.preframe &~ FF_FRAMEMASK
				player.mo.frame = $ + min(player.mo.preframe & FF_FRAMEMASK, skins["ace"].sprites[player.mo.sprite2].numframes - 1)
			end
		end
	end
end)

-- Wall Collision

addHook("MobjMoveBlocked", function(mo, mobj, wall)
	if mo and mo.valid and mo.player and mo.skin == "ace"
		if mo.player.powers[pw_carry] or (mo.player.wiz and mo.player.wiz.ondragon)
		or mo.player.powers[pw_super] return end
		
		P_SlideMove(mo)
		
		mo.player.powers[pw_pushing] = 3
		
		if wall and wall.valid
			if (wall.frontsector)
				if (wall.frontsector.ceilingheight == wall.frontsector.floorheight
				and mo.z + mo.height > wall.frontsector.ceilingheight)
					return
				end
			end
			
			if (wall.backsector)
				if (wall.backsector.ceilingheight == wall.backsector.floorheight
				and mo.z + mo.height > wall.backsector.ceilingheight)
					return
				end
			end
			
			local directangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
			
			mo.player.wiz.wall = wall
			mo.player.wiz.wallnormal = R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x, mo.y, mo.player.wiz.wall))
			
			-- Wall Bonk
			
			if ((mo.player.wiz.jumpability and (mo.player.wiz.element == 2 or mo.player.wiz.element == 3))
			or (mo.player.wiz.diving and (not (mo.player.cmd.buttons & X) or mo.player.wiz.swimming))
			or (mo.player.wiz.sprinting and mo.player.dashmode > 3*TICRATE))
				if abs(mo.player.drawangle - directangle) > ANGLE_45
					if abs(mo.player.speed) >= 24*FRACUNIT
						mo.player.wiz.wallbonk = 25
						mo.player.wiz.divedelay = mo.player.wiz.wallbonk + 10
						
						mo.player.drawangle = mo.player.wiz.wallnormal
						
						P_Thrust(mo, mo.player.wiz.wallnormal, FixedMul(-5*FRACUNIT, mo.scale))
						
						if not mo.player.wiz.swimming
							P_SetObjectMomZ(mo, FixedMul(8*FRACUNIT, mo.scale))
						end
						
						S_StartSound(mo, sfx_s3k49)
					else
						mo.player.wiz.banstate = true
					end
				else
					P_ReturnThrustX(mo, directangle, mo.player.rmomx)
					P_ReturnThrustY(mo, directangle, mo.player.rmomy)
					
					mo.player.drawangle = directangle
				end
			elseif mo.player.wiz.jumpability and mo.player.wiz.element == 1 and abs(mo.player.speed) >= 5*FRACUNIT
				P_BounceMove(mo)
				
				if mo.player.wiz.element == 1
					S_StartSound(mo, sfx_s3k44)
				end
				
				mo.player.wiz.mana = min($+10, 100)
				
				mo.player.drawangle = directangle
			end
		//elseif mobj and mobj.valid
			
		end
	else
		return
	end
	
	return true
end, MT_PLAYER)

-- Spring Check

local function SpringCheck(mo, spring)
	if not (spring and spring.valid)
	or not (mo and mo.valid) or mo.skin != "ace"
		return
	end
	
	if (spring.flags & MF_SPRING)
	and mo.z <= spring.z + spring.height
	and mo.z + mo.height >= spring.z
		mo.player.wiz.jumpabilitydelay = mobjinfo[spring.type].mass/FRACUNIT
		mo.player.wiz.slidetime = mobjinfo[spring.type].damage/FRACUNIT
	end
end

addHook("MobjCollide", SpringCheck, MT_PLAYER)
addHook("MobjMoveCollide", SpringCheck, MT_PLAYER)

-- Player Attacks

addHook("PlayerCanDamage", function(player)
	if player.mo.valid and player.mo.skin == "ace"
		if (player.wiz.jumpability and player.wiz.element == 3)
		or player.wiz.sliding or player.wiz.diving
			return true
		end
	end
end)

-- Player Protection

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.skin == "ace"
	and not (damagetype & DMG_DEATHMASK)
		if target.player.wiz.jumpability and target.player.wiz.element == 1
		and damagetype and damagetype == DMG_WATER
			return false
		end
		
		if target.player.wiz.jumpability and target.player.wiz.element == 3
		and damagetype and damagetype == DMG_FIRE
			return false
		end
	end
end, MT_PLAYER)

-- Casted Elements

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid and mobj.tracer
	and mobj.tracer.player and mobj.tracer.player.valid
		if (mobj.type != MT_ACEEARTH and mobj.type != MT_ACEBOULDER and mobj.type != MT_ACEWATER
		and mobj.type != MT_ACEAIR and mobj.type != MT_ACEFIRE) return end
		
		if mobj.type != MT_ACEBOULDER
			mobj.info.speed = 30*FRACUNIT + mobj.tracer.player.speed
		end
		
		if mobj.type == MT_ACEAIR
			if mobj.tracer.player.wiz.castcarry and mobj.tracer.player.wiz.castcarrymobj and mobj.tracer.player.wiz.castcarrymobj.valid
				mobj.info.speed = 10*FRACUNIT + mobj.tracer.player.speed
				
				P_MoveOrigin(mobj,
				ARTH_Ace.Ease(FRACUNIT/3, mobj.x, mobj.tracer.player.wiz.castcarrymobj.x),
				ARTH_Ace.Ease(FRACUNIT/3, mobj.y, mobj.tracer.player.wiz.castcarrymobj.y),
				ARTH_Ace.Ease(FRACUNIT/3, mobj.z, mobj.tracer.player.wiz.castcarrymobj.z))
			end
		end
	end
end)

local function ElementsCollide(mobj, target)
	if not target or not target.valid or not mobj or not mobj.valid
	or not (mobj.z <= target.z + target.height and target.z <= mobj.z + mobj.height)
	or (mobj.type != MT_ACEEARTH and mobj.type != MT_ACEBOULDER and mobj.type != MT_ACEWATER
	and mobj.type != MT_ACEBUBBLE and mobj.type != MT_ACEAIR and mobj.type != MT_ACECLOUD
	and mobj.type != MT_ACEFIRE and mobj.type != MT_ACEFIREBALL and mobj.type != MT_DRACOFIREBALL) return end
	if not mobj.tracer or not mobj.tracer.valid or mobj.tracer == target return false end
	
	if target and target.valid -- Earth
		if (mobj.type == MT_ACEEARTH or mobj.type == MT_ACEBOULDER or mobj.type == MT_ACEFIREBALL or mobj.type == MT_DRACOFIREBALL)
			if ((target.flags & MF_PUSHABLE) or ((target.flags & MF_ENEMY) or target.wasenemy) or (target.flags & MF_BOSS))
				P_DamageMobj(target, mobj, mobj.tracer)
			elseif (target.flags & MF_MONITOR)
				P_KillMobj(target, mobj, mobj.tracer)
			end
			
			if (target.type == MT_SPIKE or target.type == MT_WALLSPIKE
			or target.type == MT_SALOONDOOR or target.type == MT_SALOONDOORCENTER) -- Here's another character that can do the ACZ2 Minecart skip.
				if target.type == MT_SALOONDOOR or target.type == MT_SALOONDOORCENTER
					P_SpawnMobjFromMobj(target, 0, 0, target.height, MT_WOODDEBRIS)
					P_SpawnMobjFromMobj(target, 0, 0, target.height - mobj.height, MT_WOODDEBRIS)
					P_SpawnMobjFromMobj(target, 0, 0, target.height/2 + mobj.height, MT_WOODDEBRIS)
					P_SpawnMobjFromMobj(target, 0, 0, target.height/2 - mobj.height, MT_WOODDEBRIS)
					
					S_StartSound(target, sfx_wbreak)
				end
				
				P_KillMobj(target, mobj, mobj.tracer)
			end
		end
	end
	
	if target and target.valid -- Water
		if (mobj.type == MT_ACEWATER or mobj.type == MT_ACEBUBBLE or mobj.type == MT_ACEAIR)
		and ((target.flags & MF_PUSHABLE) or ((target.flags & MF_ENEMY) or target.wasenemy)
		or (target.flags & MF_BOSS) or (target.flags & MF_FIRE) or (target.flags & MF_MONITOR))
			if not (target.flags & MF_MONITOR)
				P_InstaThrust(target, (mobj.tracer.player.wiz.casting and mobj.tracer.player.drawangle or mobj.angle),
				((mobj.flags & MF_PUSHABLE) and min(mobj.tracer.player.speed + PUSHACCEL*5, mobjinfo[mobj.type].speed) or mobj.tracer.player.speed + PUSHACCEL*5))
			else
				if mobj.type != MT_ACEAIR
					P_KillMobj(target, mobj, mobj.tracer, DMG_WATER)
				end
			end
			
			if (target.flags & MF_FIRE)
				if target.target
					if target.target.burning
						target.target.burning = false
					end
				end
				
				local Smoke = P_SpawnMobj(target.x, target.y, target.z + target.height/4, MT_EXPLODE)
				
				Smoke.scale = target.radius/8
				
				P_SetObjectMomZ(Smoke, target.momz/4 + FRACUNIT)
				
				S_StartSound(Smoke, sfx_steam1)
				
				if ((target.flags & MF_PUSHABLE) or ((target.flags & MF_ENEMY) or target.wasenemy) or (target.flags & MF_BOSS))
					P_DamageMobj(target, mobj, mobj.tracer, DMG_WATER)
				elseif mobj.type != MT_ACEAIR
					P_KillMobj(target, mobj, mobj.tracer, DMG_WATER)
				end
			end
		end
	end
	
	if target and target.valid -- Air
		if mobj.type == MT_ACEAIR and ((target.flags & MF_PUSHABLE)
		or ((target.flags & MF_ENEMY) or target.wasenemy) or (target.flags & MF_BOSS))
			if not mobj.tracer.player.wiz.castcarrymobj and not (target.flags & MF_BOSS)
				if mobj.tracer.player.kvars and mobj.tracer.player.kvars.wiz -- Kirby check
					mobj.tracer.player.kvars.wiz.castcarry = true
					mobj.tracer.player.kvars.wiz.castcarrymobj = target
				else
					mobj.tracer.player.wiz.castcarry = true
					mobj.tracer.player.wiz.castcarrymobj = target
				end
			end
		end
	end
	
	if target and target.valid -- Fire
		if (mobj.type == MT_ACEFIRE or mobj.type == MT_ACEFIREBALL or mobj.type == MT_DRACOFIREBALL)
			if ((target.flags & MF_PUSHABLE) or ((target.flags & MF_ENEMY)
			or target.wasenemy) or (target.flags & MF_BOSS) or (target.flags & MF_MONITOR))
				if not (target.flags & MF_MONITOR)
					P_DamageMobj(target, mobj, mobj.tracer, DMG_FIRE)
				else
					P_KillMobj(target, mobj, mobj.tracer, DMG_FIRE)
				end
				
				if mobj.type == MT_DRACOFIREBALL
					mobj.state = mobjinfo[MT_DRACOFIREBALL].deathstate
				end
			end
			
			if target.type == MT_FLAMEHOLDER or target.type == MT_TORCHFLOWER -- No more arson!
				local Flame = P_SpawnMobj(target.x, target.y, target.z + target.height, MT_FLAME)
				
				S_StartSound(target, sfx_s1b3)
			end
		end
	end
end

addHook("MobjCollide", ElementsCollide)
addHook("MobjMoveCollide", ElementsCollide)

addHook("MobjThinker", function(enemy)
	if not enemy.wasenemy or not enemy.wasspecial return end
	
	if enemy and enemy.valid
		if P_IsObjectOnGround(enemy)
			if enemy.wasenemy
				enemy.flags = $|MF_ENEMY
				enemy.wasenemy = false
			end
			
			if enemy.wasspecial
				enemy.flags = $|MF_SPECIAL
				enemy.wasspecial = false
			end
		end
	end
end)