-- Player Mana

local function TouchMana(special, toucher)
	if special and special.valid and toucher and toucher.valid
	and toucher.player and not toucher.player.bot and (toucher.skin == "ace"
	or (toucher.skin == "kirby" and toucher.player.kvars.wiz))
	and toucher.player.powers[pw_carry] != CR_NIGHTSMODE
	and toucher.player.powers[pw_carry] != CR_NIGHTSFALL
	and toucher.player.wiz.mana < 100 and (special.type == MT_ACEMANA
	or toucher.player.starpostnum < special.health)
		if special.type != MT_ACEMANA
			ARTH_Ace.GainMana(special, toucher.player, 10)
		else
			toucher.player.wiz.mana = $+1
		end
	end
end

addHook("TouchSpecial", TouchMana, MT_STARPOST)

-- Mana Init

freeslot("MT_ACEMANA", "SPR_AMNA", "S_ACEMANA", "SPR_AMSK", "S_ACEMANA_COLLECT")

mobjinfo[MT_ACEMANA] =
{
	spawnstate = S_ACEMANA,
	deathstate = S_ACEMANA_COLLECT,
	//deathsound = sfx_s227,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_SPECIAL
}

states[S_ACEMANA] = {SPR_AMNA, FF_ANIMATE|FF_FULLBRIGHT|A, -1, nil, 7, 3}
states[S_ACEMANA_COLLECT] = {SPR_AMSK, FF_ANIMATE|FF_FULLBRIGHT|A, 18, nil, 8, 2, S_NULL}

-- Gain Mana

---- From Enemy

addHook("MobjDeath", function(mobj, inflictor, source, damage, damagetype)
	if mobj and mobj.valid and (mobj.flags & MF_ENEMY)
	and source and source.valid and source.player and (source.skin == "ace"
	or (source.skin == "kirby" and source.player.kvars.wiz))
	and source.player.powers[pw_carry] != CR_NIGHTSMODE
	and source.player.powers[pw_carry] != CR_NIGHTSFALL
	and source.player.wiz.mana < 100
		ARTH_Ace.GainMana(mobj, source.player, 10)
	end
end)

---- From Boss

addHook("MobjDamage", function(mobj, inflictor, source, damage, damagetype)
	if mobj and mobj.valid and (mobj.flags & MF_BOSS)
	and source and source.valid and source.player and (source.skin == "ace"
	or (source.skin == "kirby" and source.player.kvars.wiz))
	and source.player.powers[pw_carry] != CR_NIGHTSMODE
	and source.player.powers[pw_carry] != CR_NIGHTSFALL
	and source.player.wiz.mana < 100
		if mobj.health and source.player.wiz.mana < 100
			if not mobj.manaaward
				mobj.manaaward = 1
			else
				mobj.manaaward = 2
			end
		else
			mobj.manaaward = 0
		end
		
		if mobj.manaaward == 2
			ARTH_Ace.GainMana(mobj, source.player, 10)
			
			if mobj.manaaward == 2
				mobj.manaaward = 0
			end
		end
	end
end)

-- Mana Thinker

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.health
			local Shine = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_THOK)
			
			P_MoveOrigin(Shine, mobj.x, mobj.y, mobj.z)
			
			Shine.color = mobj.color
			Shine.frame = FF_FULLBRIGHT|FF_TRANS90
			
			Shine.scale = mobj.scale/2
			Shine.scalespeed = FRACUNIT/16
			Shine.destscale = 0
		end
		
		if mobj.target
			mobj.momx = P_RandomRange(-10, 10)*FRACUNIT//*P_MobjFlip(mobj.target)
			mobj.momy = P_RandomRange(-10, 10)*FRACUNIT//*P_MobjFlip(mobj.target)
			mobj.momz = P_RandomRange(10, 15)*FRACUNIT//*P_MobjFlip(mobj.target)
			
			A_HomingChase(mobj, 30*FRACUNIT+mobj.target.player.speed)
		end
	end
end, MT_ACEMANA)

addHook("TouchSpecial", TouchMana, MT_ACEMANA)